Package com.ads.services.webservice

# Class MappingManagerService

java.lang.Object
com.ads.services.webservice.MappingManagerService

public class MappingManagerService extends Object
The Simple Object Access Protocol or SOAP is a protocol for sending and receiving messages between applications
Web Services are based on the SOAP protocol.The response can be either JSON or XML.
Contains the methods related to perform the operations such as creation, updation, deletion and retrieval of Projects, Mappings, Subjects, MappingSpecifications and Documents, cloneMapping, versioning the map, Baseline Project, Publish the mappings, upload mappings and export mappings.
All the WebServices methods have return type String - meaning if the method is execution is successful, then it will return a string in the form of JSON or XML String based on the outputFormat parameter given by the user.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `MappingManagerService()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `addMappingDocument(String userName, String password, String outputFormat, int mapId, String document)`
  Mapping Document will be added for the specified mapId.
  `String`
  `addMappingDocumentByMapName(String userName, String password, String outputFormat, String nodeType, int nodeId, String mapName, String document)`
  Mapping Document will be added for the specified mapName.
  `String`
  `addMappingSpecification(String userName, String password, String outputFormat, int mapId, String mmMapSpecRowObjJson)`
  Inserts a single row of mappingSpecification for the specified mapId and mappingSpecificationRow.
  `String`
  `addMappingSpecifications(String userName, String password, String outputFormat, int mapId, String mmMapSpecRowObjJsonArray)`
  Inserts List of mappingSpecifications into the specified mapId.
  `String`
  `baselineProject(String userName, String password, String outputFormat, int projectId, String versionLabel, String changeDescription)`
  Appends the baseline to the project for the specified projectId.
  `String`
  `cloneMappingByName(String userName, String password, String outputFormat, String srcnodeType, int srcNodeId, String srcMapName, boolean createNewVersion, String newMapName, String tgtnodeType, int tgtNodeId)`
  Clone Mapping creates another copy of the map.
  `String`
  `cloneMappingWithNewVersion(String userName, String password, String outputFormat, int srcMapId, boolean createNewVersion, String newMapName, String tgtnodeType, int tgtNodeId)`
  Clone Mapping creates another copy of the map with newVersion.
  `String`
  `createMapping(String userName, String password, String outputFormat, String mmMappingObjJson)`
  Creates Mapping for the specified Mapping Object in the form of JSON where in specifying the projectId, mappingName are Mandatory in the Mapping Object.
  `String`
  `createMappings(String userName, String password, String outputFormat, String mappings, boolean addSpecifications)`
  Creates Mappings for the specified mapping objects,addSpecifications and outputFormat.
  `String`
  `createMappingsWithFillOptions(String userName, String password, String outputFormat, String mappings, int fillOptions)`
  Creates Mappings for the specified mapping objects and fillOptions.
  `String`
  `createMappingWithSpecifications(String userName, String password, String outputFormat, String mmMappingObjJson, boolean addSpecifications)`
  Creates Mapping for the specified mapping object,addSpecifications and outputFormat.
  `String`
  `createProject(String userName, String password, String outputFormat, String mmProjectObjJson)`
  Creates a project for the specified Project Object in JSON.
  `String`
  `createSubject(String userName, String password, String outputFormat, String mmSubjectObjJson)`
  Creates a Subject for the specified Subject Object .
  `String`
  `createSubjectByName(String userName, String password, String outputFormat, int projectId, int parentSubjectId, String subjectName)`
  Creates Subject for the specified ProjectId, ParentSubjectId, SubjectName.
  `String`
  `createSubjectWithDescription(String userName, String password, String outputFormat, int projectId, int parentSubjectId, String subjectName, String subjectDescription)`
  Creates Subject for the specified ProjectId, ParentSubjectId, SubjectName and SubjectDescription.
  `String`
  `deleteMapByName(String userName, String password, String outputFormat, String nodeType, int nodeId, String mapName, String versionMode, float versionNo)`
  Deletes the map for the specified mapName of the given nodeType and nodeId.
  `String`
  `deleteMapping(String userName, String password, String outputFormat, int mappingId)`
  Deletes Mapping for the specified mappingId.outputFormat can be either JSON or XML.
  `String`
  `deleteMappingByMapId(String userName, String password, String outputFormat, int mapId, String versionMode, float versionNo)`
  Deletes the mapping of the specified mapId, versionMode.
  `String`
  `deleteMappings(String userName, String password, String outputFormat, String mappingIdsJsonArray, String versionMode, float versionNo)`
  Deletes the mappings of the specified mappingIds.
  `String`
  `deleteMappingsByListOfMapNames(String userName, String password, String outputFormat, String nodeType, int nodeId, String mapNamesJsonArray, String versionMode, float versionNo)`
  Deletes the mappings of the specified List of mapNames of the given nodeType and nodeId.
  `String`
  `deleteMappingsByNodeType(String userName, String password, String outputFormat, String nodeType, int nodeId, String versionMode, float versionNo)`
  Deletes the mappings of the given nodeType and nodeId.
  `String`
  `deleteMappingSpecification(String userName, String password, String outputFormat, int mappingSequenceId)`
  Deletes mappingSpecification for the specified mappingSequenceId.outputFormat can be either Json or XML.
  `String`
  `deleteMappingSpecificationRow(String userName, String password, String outputFormat, String mappingSpecificationRowJsonObj)`
  Deletes the mappingSpecificationRow for the specified mappingSpecificationRow Object.
  `String`
  `deleteMappingSpecificationRows(String userName, String password, String outputFormat, String mappingSpecificationRowsJsonArray)`
  Deletes the mappingSpecifications for the specified List of mappingSpecificationRows.
  `String`
  `deleteMappingSpecifications(String userName, String password, String outputFormat, int mappingId)`
  Deletes all the mappingSpecification rows for the specified mappingId.outputFormat can be either Json or XML.
  `String`
  `deleteMappingSpecificationsWithMapSeqIds(String userName, String password, String outputFormat, String mapSeqIdsJsonArray)`
  Deletes all mappingSpecification rows for the specified MapSeqIds.
  `String`
  `deleteProject(String userName, String password, String outputFormat, int projectId)`
  Deletes a project for the specified projectId.
  `String`
  `deleteSubject(String userName, String password, String outputFormat, int subjectId)`
  Deletes the subject for the specified subjectId.
  `String`
  `exportAll(String userName, String password, String outputFormat, String nodeType, int nodeId, String selectionCriteria, String exportOption, boolean includePseudoCode, boolean visibleColumns)`
  Mapping Specifications are exported to excel for the specified nodeId.
  `String`
  `exportMappingToExcel(String userName, String password, String outputFormat, int mapId, boolean visibleColumns, boolean includePseudocode)`
  Mapping Specification is exported to excel for the specified mapId.Specifying the mapId is mandatory.
  `String`
  `exportMappingToExcelWithMapName(String userName, String password, String outputFormat, String nodeType, int nodeId, String mapName, boolean visibleColumns, boolean includePseudocode)`
  Mapping Specification is exported to excel for the specified mapName.
  `String`
  `exportMappingXml(String userName, String password, String outputFormat, String nodeType, int nodeId, String selectionCriteria)`
  Mapping Specifications are exported to XML for the specified nodeId.
  `String`
  `getMapping(String userName, String password, String outputFormat, int nodeId, String nodeType, String mapName, float versionNo)`
  Returns all the information relating to the specified mapName, such as mappingDescription, mappingSpecVersion, mappingStatus,
  mappingPlannedDevelopmentEffort, actualEffort, testingNotes, versionLabel, userDefined Fields, AuditFields etc...
  `String`
  `getMappingById(String userName, String password, String outputFormat, int mappingId)`
  Returns Mapping Object in the form of specified outputFormat for the specified mappingId.
  `String`
  `getMappingByName(String userName, String password, String outputFormat, int parentNodeId, String mappingName, String nodeType)`
  Returns Mapping Object for the specified parentNodeId, mappingName, nodeType and outputFormat.outputFormat can be either JSON or XML.
  `String`
  `getMappingComplete(String userName, String password, String outputFormat, int mappingId, boolean fillSpecification, boolean fillDocuments)`
  Returns Mapping Object for the specified mappingId, fillSpecifications, fillDocuments and outputFormat.outputFormat can be either JSON or XML.
  `String`
  `getMappingDocuments(String userName, String password, String outputFormat, int mappingId)`
  Returns the List of Mapping Document objects for the specified mappingId.outputFormat can be either JSON or XML.
  `String`
  `getMappingId(String userName, String password, String outputFormat, String projectName, String mappingName)`
  Returns the mappingId for the specified mappingName and projectName.outputFormat can be either JSON or XML.
  `String`
  `getMappingIdByName(String userName, String password, String outputFormat, int parentNodeId, String mappingName, String nodeType)`
  Returns the mappingId for the specified parentNodeId,mappingName,nodeType.
  `String`
  `getMappings(String userName, String password, String outputFormat, int parentNodeId, String nodeType)`
  Returns List of Mappings for the specified parentNodeId, nodeType.
  `String`
  `getMappingsByProjectId(String userName, String password, String outputFormat, int projectId, boolean fillSpecifications, boolean fillDocuments)`
  Returns List of Mappings for the specified projectId, fillSpecifications, fillDocuments.outputFormat can be either JSON or XML.
  `String`
  `getMappingsByProjectName(String userName, String password, String outputFormat, String projectName, boolean fillSpecifications, boolean fillDocuments)`
  Returns List of mappings for the specified project Name, fillSpecifications, fillDocuments and outputFormat.outputFormat can be either JSON or XML.
  `String`
  `getMappingsBySubjectId(String userName, String password, String outputFormat, int subjectId, boolean fillSpecifications, boolean fillDocuments)`
  Returns a List of mappings for the specified subjectId, fillSpecifications, fillDocuments and outputFormat.outputFormat can be either JSON or XML.
  `String`
  `getMappingsBySubjectName(String userName, String password, String outputFormat, String subjectName, boolean fillSpecifications, boolean fillDocuments)`
  Returns List of mappings for the specified subject Name, fillSpecifications, fillDocuments in the JSON.outputFormat can be either JSON or XML.
  `String`
  `getMappingSpecifications(String userName, String password, String outputFormat, int mappingId)`
  Returns the List of Mapping Specifications for the specified mappingId.outputFormat can be either Json or XML.
  `String`
  `getMappingSpecificationsWithMapSeqIds(String userName, String password, String outputFormat, String mapSeqIdsJsonArray)`
  Returns the List of Mapping Specifications for the specified mapSpecIds.
  `String`
  `getMappingsWithMapIds(String userName, String password, String outputFormat, String mapIdsJsonArray, boolean fillSpecifications, boolean fillDocuments)`
  Returns List of Mappings for the specified List of mapIds.
  `String`
  `getMappingWithSpecifications(String userName, String password, String outputFormat, int mappingId, boolean fillSpecification)`
  Returns Mapping Object for the specified mappingId, fillSpecification.
  `String`
  `getProject(String userName, String password, String outputFormat, int projectId)`
  Returns the Project object for the specified projectId in the specified outputFormat.
  `String`
  `getProjectByName(String userName, String password, String outputFormat, String projectName)`
  Returns the Project object for the specified project Name in the specified outputFormat.outputFormat can be either JSON or XML.
  `String`
  `getProjectDocuments(String userName, String password, String outputFormat, int projectId)`
  Returns the List of project Documents for the specified projectId in the specified outputFormat.outputFormat can be either JSON or XML.
  `String`
  `getProjectId(String userName, String password, String outputFormat, String projectName)`
  Returns the projectId for the specified projectName in the specified outputFormat.
  `String`
  `getProjects(String userName, String password, String outputFormat)`
  Returns the List of all Projects where each project contains details like projectName, projectDescription, projectDocuments etc...
  `String`
  `getProjectsWithDepth(String userName, String password, String outputFormat, String depth)`
  Returns the projects and its Details according to the specified Depth.
  `String`
  `getSubject(String userName, String password, String outputFormat, int projectId, int parentSubjectId, String subjectName)`
  Returns Subject Object for the specified projectId, parentSubjectId, subjectName in the specified outputFormat.outputFormat can be either JSON or XML.
  `String`
  `getSubjectByHierarchy(String userName, String password, String outputFormat, String projectName, String subjectHierarchy)`
  Returns Subject object for the specified projectName and subjectHierarchy, in the specified outputFormat.
  `String`
  `getSubjectById(String userName, String password, String outputFormat, int subjectId)`
  Returns Subject Object for the specified subjectId in the specified outputFormat.
  `String`
  `getSubjectByProject(String userName, String password, String outputFormat, int projectId, String subjectHierarchy)`
  Returns Subject object for the specified projectId and subjectHierarchy, in the specified outputFormat.
  `String`
  `getSubjectId(String userName, String password, String outputFormat, String projectName, String subjectName)`
  Returns subjectId for the specified projectName, SubjectName and outputFormat.outputFormat can be either JSON or XML.
  `String`
  `getSubjectIdByName(String userName, String password, String outputFormat, int parentNodeId, String subjectName, String nodeType)`
  Returns the subjectId for the specified parentNodeId, subjectName, nodeType.outputFormat can be either JSON or XML.
  `String`
  `getSubjects(String userName, String password, String outputFormat, String projectName)`
  Returns the List of subjects for the specified projectName in the specified outputFormat.
  `String`
  `getSubjectsByProjectId(String userName, String password, String outputFormat, int projectId)`
  Returns the List of subjects for the specified projectId in the form of specified outputFormat.outputFormat can be either JSON or XML.
  `String`
  `mergeMapping(String userName, String password, String outputFormat, int srcMapId, int tgtMapId, boolean createNewVersion, String changeDescription)`
  Merge Mapping combines the mapping specifications of one map in to the other map.I.e it copies the map specified at srcMapId and merges with the map specified at tgtMapId.
  `String`
  `mergeMappingByName(String userName, String password, String outputFormat, String srcNodeType, int srcNodeId, String srcMapName, String tgtNodeType, int tgtNodeId, String tgtMapName, boolean createNewVersion, String changeDescription)`
  Merge Mapping combines the mapping specifications of one map in to the other map.i.e it copies the map specified at srcNodeId with srcMapName and merges with the map specified at tgtNodeId with the tgtMapName.
  `String`
  `moveMapping(String userName, String password, String outputFormat, int srcMapId, String tgtnodeType, int tgtNodeId, boolean replaceIfExists, String newMapName)`
  Move Mapping moves the map from one node to the other node.
  `String`
  `moveMappingWithNewMapName(String userName, String password, String outputFormat, String srcNodeType, int srcNodeId, String srcMapName, String tgtnodeType, int tgtNodeId, boolean replaceIfExists, String newMapName)`
  Move Mapping moves the map from one node to the other node.
  `String`
  `publishMapping(String userName, String password, String outputFormat, int mapId, Date effectiveDate, String changeDescription, String publishNotes)`
  Mapping will be published for the specified mapId.
  `String`
  `publishMappingByName(String userName, String password, String outputFormat, int nodeId, String nodeType, String mapName, Date effectiveDate, String changeDescription, String publishNotes)`
  Mapping will be published for the specified mapName.
  `String`
  `publishMappings(String userName, String password, String outputFormat, String mapIdsJsonArray, Date effectiveDate, String changeDescription, String publishNotes)`
  Mappings will be published for the specified mapIds in the JSON.
  `String`
  `setMappingLock(String userName, String password, String outputFormat, int mapId, boolean lockStatus)`
  SetMappingLock method either Locks or Unlocks the specified Map.
  `String`
  `setMappingLockByMapName(String userName, String password, String outputFormat, String nodeType, int nodeId, String mapName, boolean lockStatus)`
  SetMappingLock method either Locks or Unlocks the specified MapName.
  `String`
  `syncMetadata(String userName, String password, String outputFormat, String mapIdsJsonArray)`
  This function is used to sync the source and target metadata information in mapping specifications for the specified map Ids.
  `String`
  `unPublishMap(String userName, String password, String outputFormat, int mapId)`
  Mapping is unpublished for the specified mapId.
  `String`
  `unPublishMapByMapName(String userName, String password, String outputFormat, String nodeType, int nodeId, String mapName, float versionNo)`
  Mapping is unpublished for the specified nodeId.Specifying the nodeId, nodeType are mandatory.
  `String`
  `updateMapping(String userName, String password, String outputFormat, String mmMappingObjJson)`
  Updates mapping for the specified Mapping Object.
  `String`
  `updateMappingSpecification(String userName, String password, String outputFormat, String MappingSpecificationRowObjJson)`
  Mapping Specification is updated with the specified MappingSpecificationRow Object.
  `String`
  `updateMappingSpecifications(String userName, String password, String outputFormat, String mappingSpecificationRowJsonArray)`
  Mapping Specifications are updated with the specified MappingSpecificationRow Objects.
  `String`
  `updateProject(String userName, String password, String outputFormat, String mmProjectObjJson)`
  Updates project for the specified Project Object.
  `String`
  `updateSubject(String userName, String password, String outputFormat, String mmSubjectObjJson)`
  Updates Subject Details for the specified Subject Object.
  `String`
  `uploadMapping(String userName, String password, String outputFormat, int nodeId, String nodeType, String mappingImportHelperJsonObj)`
  Uploads the mappingSpecifications on the specified nodeId, nodeType and of the importFileType, importType, filePath and filePathType specified in MappingImportHelper Object.
  `String`
  `uploadMappingByMapId(String userName, String password, String outputFormat, int mapId, String mappingImportHelperJsonObj)`
  Uploads the mappingSpecifications on the specified mapId and of the importFileType, importType specified in MappingImportHelper Object.
  `String`
  `versionMapping(String userName, String password, String outputFormat, String mmMappingObjJson)`
  Appends mapping version for the specified Mapping Object.outputFormat can be either Json or XML.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### MappingManagerService

    public MappingManagerService()

- ## Method Details

  - ### createProject

    public String createProject(String userName, String password, String outputFormat, String mmProjectObjJson)
    Creates a project for the specified Project Object in JSON. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Specifying the projectName is Mandatory along with the other information regarding project.
    Parameters:
      `mmProjectObjJson` - JSON String
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Project is added successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'mmProjectObjJson' JSON :
      {
      "projectDescription": "",
      "projectName": "",
      "projectCostCenter": "",
      "projectOwnerFullName": "",
      "projectBusinessSponsorFullName": "",
      "projectDocuments": [],
      "projectResources": [
      {
      "resourceId": "",
      "roleId": "",
      "assignedRole": "",
      "assignedResponsibilites": null
      },
      {
      "resourceId": "",
      "roleId": "",
      "assignedRole": "",
      "assignedResponsibilites": null
      }
      ],
      "projectITSponsorFullName": "",
      "nodeId": "",
      "projectId": 0,
      "projectETL": "INFORMATICA_PSEUDOCODE"
      }

    Since:
      6.2

  - ### getProject

    public String getProject(String userName, String password, String outputFormat, int projectId)
    Returns the Project object for the specified projectId in the specified outputFormat. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Specifying the projectId is Mandatory, based on which it returns the details like projectName, projectDescription, costCenter, projectOwnerName, sponserName, businessSponserName, projectDocument details and projectResources details.
    Parameters:
      `projectId` - int
      `userName` - String
      `password` - String
      `outputFormat` - String- Valid values: JSON or XML
    Returns:
      String - Project Object in the form of JSON or XML String.
    Since:
      6.2

  - ### getProjectByName

    public String getProjectByName(String userName, String password, String outputFormat, String projectName)
    Returns the Project object for the specified project Name in the specified outputFormat.outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Specifying the projectName is Mandatory, Based on which it returns the details like projectName, projectDescription, costCenter, projectOwnerName,sponserName, businessSponserName, projectDocument details and projectResources details.
    Parameters:
      `projectName` - String
      `userName` - String
      `password` - String
      `outputFormat` - String- Valid values: JSON or XML
    Returns:
      String - Project Object in the form of JSON String.
    Since:
      6.2

  - ### getProjectId

    public String getProjectId(String userName, String password, String outputFormat, String projectName)
    Returns the projectId for the specified projectName in the specified outputFormat. Specifying the projectName is Mandatory. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `projectName` - String
      `userName` - String
      `password` - String
      `outputFormat` - String- Valid values: JSON or XML
    Returns:
      String - projectId
    Since:
      6.2

  - ### getProjects

    public String getProjects(String userName, String password, String outputFormat)
    Returns the List of all Projects where each project contains details like projectName, projectDescription, projectDocuments etc... outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String- Valid values: JSON or XML
    Returns:
      String - List of Project Objects in the form of JSON String.
    Since:
      6.2

  - ### getProjectDocuments

    public String getProjectDocuments(String userName, String password, String outputFormat, int projectId)
    Returns the List of project Documents for the specified projectId in the specified outputFormat.outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Specification of projectId is mandatory, based on the specified projectId it returns the list of all associated documents where each document contains details like documentName,documentOwner, documentObject and documentLink etc.The filePath in the returned document object is RELATIVE.
    Parameters:
      `projectId` - int
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - List of Document objects in the form of JSON String.
    Since:
      6.2

  - ### updateProject

    public String updateProject(String userName, String password, String outputFormat, String mmProjectObjJson)
    Updates project for the specified Project Object. All the information pertaining to the project can be updated.outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Specifying projectId and projectName are Mandatory.
    Parameters:
      `mmProjectObjJson` - JSON String
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Project is updated successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'mmProjectObjJson' JSON :
      {
      "projectDescription": "",
      "projectName": "",
      "projectCostCenter": "",
      "projectOwnerFullName": "",
      "projectBusinessSponsorFullName": "",
      "projectDocuments": [],
      "projectResources": [
      {
      "resourceId": "",
      "roleId": "",
      "assignedRole": "",
      "assignedResponsibilites": null
      },
      {
      "resourceId": "",
      "roleId": "",
      "assignedRole": "",
      "assignedResponsibilites": null
      }
      ],
      "projectITSponsorFullName": "",
      "nodeId": "",
      "projectId": 0
      }

    Since:
      6.2

  - ### deleteProject

    public String deleteProject(String userName, String password, String outputFormat, int projectId)
    Deletes a project for the specified projectId. Specifying projectId is mandatory to delete a particular project.outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `projectId` - int
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If a Project is deleted successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      6.2

  - ### createSubject

    public String createSubject(String userName, String password, String outputFormat, String mmSubjectObjJson)
    Creates a Subject for the specified Subject Object . outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Specifying projectId and subjectName are Mandatory to create a subject.
    Parameters:
      `mmSubjectObjJson` - JSON String
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If a Subject is added successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'mmSubjectObjJson' JSON :
      {
      "parentSubjectId": -1,
      "subjectId": 0,
      "userDefined10": "",
      "subjectDescription": "",
      "userDefined11": "",
      "userDefined12": "",
      "subjectName": "S1",
      "subjectChangedDescription": "",
      "userDefined13": "",
      "userDefined14": "",
      "userDefined15": "",
      "considerUserDefinedFlag": "",
      "userDefined8": "",
      "userDefined9": "",
      "userDefined6": "",
      "userDefined7": "",
      "userDefined4": "",
      "userDefined5": "",
      "userDefined2": "",
      "userDefined3": "",
      "nodeId": "",
      "projectId": 0,
      "userDefined1": ""
      }

    Since:
      6.2

  - ### getSubject

    public String getSubject(String userName, String password, String outputFormat, int projectId, int parentSubjectId, String subjectName)
    Returns Subject Object for the specified projectId, parentSubjectId, subjectName in the specified outputFormat.outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Specifying the projectId,parentSubjectId and subjectName are Mandatory. Based on which it returns all the details of subject.
    Parameters:
      `projectId` - int
      `parentSubjectId` - int
      `subjectName` - String
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - Subject object in the form of JSON or XML String.
    Since:
      6.2

  - ### getSubjectById

    public String getSubjectById(String userName, String password, String outputFormat, int subjectId)
    Returns Subject Object for the specified subjectId in the specified outputFormat. Specifying the subjectId is Mandatory based on which the subject Object is retrieved.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `subjectId` - int
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - Subject object in the form of JSON String.
    Since:
      6.2

  - ### getSubjects

    public String getSubjects(String userName, String password, String outputFormat, String projectName)
    Returns the List of subjects for the specified projectName in the specified outputFormat.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Specification of projectName is Mandatory, based on which it returns the list of all subjects and their information present in that particular project.
    Parameters:
      `projectName` - String
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - List of Subject objects in the form of JSON String.
    Since:
      6.2

  - ### getSubjectIdByName

    public String getSubjectIdByName(String userName, String password, String outputFormat, int parentNodeId, String subjectName, String nodeType)
    Returns the subjectId for the specified parentNodeId, subjectName, nodeType.outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    The value of nodeType can be MM_SUBJECT or MM_PROJECT.Based on the nodeType, parentNodeId changes.
    If the nodeType is MM_SUBJECT, parentNodeId will be subjectId whereas if the nodeType is MM_PROJECT then parentNodeId will be projectId.
    Parameters:
      `parentNodeId` - int
      `subjectName` - String
      `nodeType` - Node
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - subjectId
    Since:
      6.2

  - ### getSubjectId

    public String getSubjectId(String userName, String password, String outputFormat, String projectName, String subjectName)
    Returns subjectId for the specified projectName, SubjectName and outputFormat.outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Specifying projectName and subjectName are Mandatory.
    Parameters:
      `projectName` - String
      `subjectName` - String
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - subjectId
    Since:
      6.2

  - ### getSubjectsByProjectId

    public String getSubjectsByProjectId(String userName, String password, String outputFormat, int projectId)
    Returns the List of subjects for the specified projectId in the form of specified outputFormat.outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Specification of projectId is mandatory, based on which it returns the list of all subjects and their information present in that particular project.
    Parameters:
      `projectId` - int
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - List of Subjects in the form of JSON String.
    Since:
      6.2

  - ### updateSubject

    public String updateSubject(String userName, String password, String outputFormat, String mmSubjectObjJson)
    Updates Subject Details for the specified Subject Object. All the subject information can be updated by providing the details in subject Object.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Specifying subjectId, subjectName are Mandatory.
    Parameters:
      `mmSubjectObjJson` - String
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Subject is updated successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'mmSubjectObjJson' JSON :
      {
      "parentSubjectId": -1,
      "subjectId": 0,
      "userDefined10": "",
      "subjectDescription": "",
      "userDefined11": "",
      "userDefined12": "",
      "subjectName": "S1",
      "subjectChangedDescription": "",
      "userDefined13": "",
      "userDefined14": "",
      "userDefined15": "",
      "considerUserDefinedFlag": "",
      "userDefined8": "",
      "userDefined9": "",
      "userDefined6": "",
      "userDefined7": "",
      "userDefined4": "",
      "userDefined5": "",
      "userDefined2": "",
      "userDefined3": "",
      "nodeId": "",
      "projectId": 0,
      "userDefined1": ""
      }

    Since:
      6.2

  - ### deleteSubject

    public String deleteSubject(String userName, String password, String outputFormat, int subjectId)
    Deletes the subject for the specified subjectId. Specifying the subjectId is mandatory to delete the subject.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `subjectId` - int
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Subject is deleted successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      6.2

  - ### createMapping

    public String createMapping(String userName, String password, String outputFormat, String mmMappingObjJson)
    Creates Mapping for the specified Mapping Object in the form of JSON where in specifying the projectId, mappingName are Mandatory in the Mapping Object.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `mmMappingObjJson` - JSON format
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Map is created successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'mmMappingObjJson' for this:
      {
      "mappingName": "",
      "mappingDescription": "",
      "projectId": 0,
      "mappingSubStateName": "",
      "publishNotes": "",
      "subjectId": 0,
      "actualMappingEffortUnits": "",
      "mappingStatus": "",
      "jobXRef": "",
      "userDefined10": "",
      "userDefined11": "",
      "userDefined12": "",
      "updateTargetMetadata": false,
      "updateSourceMetadata": false,
      "userDefined13": "",
      "mappingSpecifications": null,
      "userDefined14": "",
      "userDefined15": "",
      "userDefined16": "",
      "published": false,
      "userDefined17": "",
      "targetUpdateStrategy": "",
      "userDefined18": "",
      "actualETLEffort": 0,
      "userDefined19": "",
      "testDisposition": "",
      "versionLabel": "",
      "plannedETLEffortUnits": "",
      "plannedETLEffort": 0,
      "userDefined8": "",
      "userDefined20": "",
      "userDefined9": "",
      "userDefined21": "",
      "userDefined6": "",
      "userDefined22": "",
      "userDefined7": "",
      "userDefined23": "",
      "userDefined4": "",
      "plannedMappingEffortUnits": "",
      "userDefined5": "",
      "userDefined2": "",
      "userDefined3": "",
      "nodeId": "",
      "userDefined1": "",
      "mappingSubStateId": 0,
      "mappingId": -1,
      "mappingStateId": 0,
      "changedDescription": "",
      "actualETLEffortUnits": "",
      "userDefined24": "",
      "userDefined25": "",
      "plannedMappingEffort": 0,
      "userDefined26": "",
      "userDefined27": "",
      "userDefined28": "",
      "userDefined29": "",
      "actualDevelopLevelOfEffort": "",
      "actualNotes": "",
      "userDefined30": "",
      "userDefined31": "",
      "testingNotes": "",
      "actualMappingEffort": 0,
      "userDefined32": "",
      "userDefined33": "",
      "sourceExtractQuery": "",
      "userDefined34": "",
      "targetUpgateStrategyNotes": "",
      "plannedDevelopmentLevelOfEffort": "",
      "sourceExtractDescription": "",
      "userDefined35": "",
      "userDefined36": "",
      "userDefined37": "",
      "userDefined38": "",
      "userDefined39": "",
      "mappingStateName": "",
      "userDefined40": "",
      "userDefined41": "",
      "plannedNotes": "",
      "userDefined42": "",
      "userDefined43": "",
      "userDefined44": "",
      "userDefined45": "",
      "mappingDocuments": null,
      "mappingSpecVersion": 1,
      "effectiveDate": null
      }

    Since:
      6.2

  - ### createMappingWithSpecifications

    public String createMappingWithSpecifications(String userName, String password, String outputFormat, String mmMappingObjJson, boolean addSpecifications)
    Creates Mapping for the specified mapping object,addSpecifications and outputFormat. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Specifying projectId and mappingName are mandatory. If the value of addSpecifications is true, mapping gets created with all the specification details provided.If the value of addSpecifications is false only empty mapping with out any specifications gets created.
    Parameters:
      `mmMappingObjJson` - String
      `addSpecifications` - boolean
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Mapping is added successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'mmMappingObjJson' JSON :
      {
      "projectId": 0,
      "mappingName": "",
      "mappingId": 0,
      "mappingSubStateName": null,
      "publishNotes": null,
      "subjectId": -1,
      "actualMappingEffortUnits": "",
      "mappingStatus": "",
      "jobXRef": "",
      "userDefined10": "",
      "userDefined11": "",
      "userDefined12": "",
      "updateTargetMetadata": false,
      "updateSourceMetadata": false,
      "userDefined13": "",
      "mappingSpecifications": [
      {
      "sourceColumnIdentityFlag": false,
      "targetSystemEnvironmentName": "",
      "targetBusinessKeyFlag": false,
      "targetColumnClass": "",
      "userDefined46": "",
      "userDefined47": "",
      "userDefined48": "",
      "userDefined49": "",
      "userDefined50": "",
      "sourcePrimaryKeyFlag": false,
      "targetColumnScale": "",
      "targetColumnAlias": "",
      "sourceSDIFlag": false,
      "targetSDIFlag": false,
      "sourceTableClass": "",
      "sourceColumnAlias": "",
      "sourceColumnScale": "",
      "extendedBusinessRule": "",
      "rowOrder": 1,
      "userDefined8": "",
      "sourceColumnDefinition": "",
      "userDefined9": "",
      "userDefined6": "",
      "userDefined7": "",
      "userDefined4": "",
      "businessRule": "",
      "userDefined5": "",
      "userDefined2": "",
      "userDefined3": "",
      "targetLogicalColumnName": "",
      "userDefined1": "",
      "sourceColumnDatatype": "",
      "sourceSDIDescription": "",
      "targetColumnDefinition": "",
      "sourceSystemEnvironmentName": "",
      "targetSystemName": "",
      "targetColumnComments": "",
      "userDefined24": "",
      "userDefined25": "",
      "userDefined26": "",
      "mappingSpecificationRowComments": "",
      "userDefined27": "",
      "userDefined28": "",
      "userDefined29": "",
      "targetColumnPrecision": "",
      "csmmappingReference": "",
      "targetNaturalKeyFlag": false,
      "userDefined30": "",
      "userDefined31": "",
      "sourceTableAlias": "",
      "userDefined32": "",
      "userDefined33": "",
      "userDefined34": "",
      "targetTableName": "",
      "sourceMinimumValue": "",
      "sourcePercentNullValue": "",
      "sourceSystemId": -1,
      "userDefined35": "",
      "userDefined36": "",
      "userDefined37": "",
      "userDefined38": "",
      "userDefined39": "",
      "sourceLogicalColumnName": "",
      "sourceColumnPrecision": "",
      "sourceMaximumValue": "",
      "userDefined40": "",
      "userDefined41": "",
      "userDefined42": "",
      "pseudocode": "",
      "userDefined43": "",
      "userDefined44": "",
      "userDefined45": "",
      "targetTableAlias": "",
      "baseSourceSystemName": "",
      "sourceTableName": "",
      "mappingSequenceId": 0,
      "userDefined10": "",
      "userDefined11": "",
      "baseSourceSystemEnvironmentName": "",
      "userDefined12": "",
      "targetPrimaryKeyFlag": false,
      "lookupColumn": "",
      "sourceColumnLength": "",
      "sourceBusinessKeyFlag": false,
      "userDefined13": "",
      "sourceNaturalKeyFlag": false,
      "userDefined14": "",
      "userDefined15": "",
      "userDefined16": "",
      "userDefined17": "",
      "targetColumnNullableFlag": false,
      "userDefined18": "",
      "userDefined19": "",
      "lookupOn": "",
      "sourceColumnDBDefaultValue": "",
      "targetColumnLength": "",
      "userDefined20": "",
      "sourceColumnComments": "",
      "userDefined21": "",
      "userDefined22": "",
      "userDefined23": "",
      "sourceSystemName": "",
      "targetSystemId": -1,
      "targetSDIDescription": "",
      "targetTableClass": "",
      "mappingId": 1,
      "specificationArtifacts": "",
      "transformationLookupCondition": "",
      "sourceColumnNullableFlag": false,
      "targetColumnName": "",
      "sourceColumnClass": "",
      "targetColumnETLDefaultValue": "",
      "baseTargetSystemEnvironmentName": "",
      "baseTargetSystemName": "",
      "targetXPath": "",
      "sourceColumnName": "",
      "sourceXPath": "",
      "columnMappingCompleteFlag": false,
      "rdmReferenceTable": "",
      "targetColumnDatatype": "",
      "sourceTableType" : "",
      "targetTableType" : "",
      "sourceEntityUID" : "",
      "targetEntityUID" : "",
      "sourceEnvBusinessEntityType": "",
      "sourceTableBusinessEntityType": "",
      "targetEnvBusinessEntityType": "",
      "targetTableBusinessEntityType": ""
      }
      ],
      "userDefined14": "",
      "userDefined15": "",
      "userDefined16": "",
      "published": false,
      "userDefined17": "",
      "targetUpdateStrategy": "",
      "userDefined18": "",
      "actualETLEffort": 0,
      "userDefined19": "",
      "testDisposition": " ",
      "versionLabel": "",
      "plannedETLEffortUnits": "",
      "plannedETLEffort": 0,
      "userDefined8": "",
      "userDefined20": "",
      "userDefined9": "",
      "userDefined21": "",
      "userDefined6": "",
      "userDefined22": "",
      "userDefined7": "",
      "userDefined23": "",
      "userDefined4": "",
      "plannedMappingEffortUnits": "",
      "userDefined5": "",
      "userDefined2": "",
      "userDefined3": "",
      "nodeId": "",
      "userDefined1": "",
      "mappingSubStateId": 0,
      "mappingStateId": 0,
      "changedDescription": "",
      "actualETLEffortUnits": "",
      "userDefined24": "",
      "userDefined25": "",
      "plannedMappingEffort": 0,
      "userDefined26": "",
      "userDefined27": "",
      "userDefined28": "",
      "userDefined29": "",
      "actualDevelopLevelOfEffort": null,
      "actualNotes": "",
      "userDefined30": "",
      "userDefined31": "",
      "testingNotes": "",
      "actualMappingEffort": 0,
      "userDefined32": "",
      "userDefined33": "",
      "sourceExtractQuery": "",
      "userDefined34": "",
      "targetUpgateStrategyNotes": "",
      "plannedDevelopmentLevelOfEffort": null,
      "sourceExtractDescription": "",
      "userDefined35": "",
      "mappingDescription": "",
      "userDefined36": "",
      "userDefined37": "",
      "userDefined38": "",
      "userDefined39": "",
      "mappingStateName": null,
      "userDefined40": "",
      "userDefined41": "",
      "plannedNotes": "",
      "userDefined42": "",
      "userDefined43": "",
      "userDefined44": "",
      "userDefined45": "",
      "mappingDocuments": null,
      "mappingSpecVersion": 0,
      "effectiveDate": null
      }

    Since:
      6.2

  - ### getMappingById

    public String getMappingById(String userName, String password, String outputFormat, int mappingId)
    Returns Mapping Object in the form of specified outputFormat for the specified mappingId. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `mappingId` - int
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - Mapping object in the form of JSON or XML String.
    Since:
      6.2

  - ### getMappingWithSpecifications

    public String getMappingWithSpecifications(String userName, String password, String outputFormat, int mappingId, boolean fillSpecification)
    Returns Mapping Object for the specified mappingId, fillSpecification. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    If fillSpecification is true, then the Mapping Object with mapping specifications is returned if false then Mapping Object without mapping specifications is returned.
    Parameters:
      `mappingId` - int
      `userName` - String
      `password` - String
      `fillSpecification` - boolean
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - Mapping object in the form of JSON or XML String.
    Since:
      6.2

  - ### getMappingComplete

    public String getMappingComplete(String userName, String password, String outputFormat, int mappingId, boolean fillSpecification, boolean fillDocuments)
    Returns Mapping Object for the specified mappingId, fillSpecifications, fillDocuments and outputFormat.outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    If the value of fillSpecifications is true then the returned Mapping Object contains mapping specifications otherwise no mapping specifications are contained in the Mapping Object. If the value of fillDocuments is true then the returned Mapping Object contains all documents associated with specified mappingId other wise no documents are contained in the Mapping Object.
    Parameters:
      `mappingId` - int
      `fillDocuments` - boolean
      `userName` - String
      `fillSpecification` - boolean
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - Mapping object in the form of JSON or XML String.
    Since:
      6.2

  - ### getMappingsBySubjectName

    public String getMappingsBySubjectName(String userName, String password, String outputFormat, String subjectName, boolean fillSpecifications, boolean fillDocuments)
    Returns List of mappings for the specified subject Name, fillSpecifications, fillDocuments in the JSON.outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Specifying the values of fillSpecifications and fillDocuments as true will return Mapping Objects with specifications and document details associated with the mappings.
    Specifying the values of fillSpecifications and fillDocuments as false will only return the details of mappings but not specifications and document details.
    Parameters:
      `subjectName` - String
      `fillSpecifications` - boolean
      `fillDocuments` - boolean
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - List of Mappings under subject in the form of JSON or XML String.
    Since:
      6.2

  - ### getMappingsBySubjectId

    public String getMappingsBySubjectId(String userName, String password, String outputFormat, int subjectId, boolean fillSpecifications, boolean fillDocuments)
    Returns a List of mappings for the specified subjectId, fillSpecifications, fillDocuments and outputFormat.outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Specifying the values of fillSpecifications and fillDocuments as true will return Mapping Objects with specifications and document details associated with the mappings.
    Specifying the values of fillSpecifications and fillDocuments as false will only return the details of mappings but not specifications or document details.
    Parameters:
      `subjectId` - int
      `fillSpecifications` - boolean
      `fillDocuments` - boolean
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - List of Mappings under subject in the form of JSON String.
    Since:
      6.2

  - ### getMappingsByProjectId

    public String getMappingsByProjectId(String userName, String password, String outputFormat, int projectId, boolean fillSpecifications, boolean fillDocuments)
    Returns List of Mappings for the specified projectId, fillSpecifications, fillDocuments.outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Specification of projectId is mandatory. Specifying the values of fillSpecifications and fillDocuments as true will return Mapping Objects with specifications and document details associated with the mappings.
    Specifying the values of fillSpecifications and fillDocuments as false will only return the details of mappings but not specifications or document details.
    Parameters:
      `projectId` - int
      `fillSpecifications` - boolean
      `fillDocuments` - boolean
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - List of Mappings in the form of JSON or XML String.
    Since:
      6.2

  - ### getMappingsByProjectName

    public String getMappingsByProjectName(String userName, String password, String outputFormat, String projectName, boolean fillSpecifications, boolean fillDocuments)
    Returns List of mappings for the specified project Name, fillSpecifications, fillDocuments and outputFormat.outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Specifying the values of fillSpecifications and fillDocuments as true will return Mapping Objects with mapping specifications and document details associated with mappings
    Specifying the values of fillSpecifications and fillDocuments as false will only return the details of mappings but not specifications or document details.
    Parameters:
      `projectName` - String
      `fillSpecifications` - boolean
      `fillDocuments` - boolean
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - List of Mappings in the form of JSON or XML String.
    Since:
      6.2

  - ### getMappingIdByName

    public String getMappingIdByName(String userName, String password, String outputFormat, int parentNodeId, String mappingName, String nodeType)
    Returns the mappingId for the specified parentNodeId,mappingName,nodeType. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    The value of nodeType can be MM_SUBJECT or MM_PROJECT.Based on the nodeType, parentNodeId changes.
    If the nodeType is MM_SUBJECT, parentNodeId will be subjectId whereas if the nodeType is MM_PROJECT then parentNodeId will be projectId.
    Parameters:
      `parentNodeId` - int
      `mappingName` - String
      `nodeType` - Node
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - mappingId in the form of JSON or XML String.
    Since:
      6.2

  - ### getMappingByName

    public String getMappingByName(String userName, String password, String outputFormat, int parentNodeId, String mappingName, String nodeType)
    Returns Mapping Object for the specified parentNodeId, mappingName, nodeType and outputFormat.outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Specification of parentNodeId, mappingName and nodeType are mandatory.NodeType can be either MM_PROJECT or MM_SUBJECT and parentNodeId can be Project Id, Subject Id depending on the nodeType.
    Parameters:
      `parentNodeId` - int
      `mappingName` - String
      `nodeType` - NodeType
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - Mapping object in the form of JSON String.
    Since:
      6.2

  - ### getMappingDocuments

    public String getMappingDocuments(String userName, String password, String outputFormat, int mappingId)
    Returns the List of Mapping Document objects for the specified mappingId.outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Specification of mappingId is mandatory, based on which it returns the list of all documents associated with the specified mappingId where each documents contains details like documentName,documentOwner,documentObject and documentLink etc.The filePath in the returned document object is RELATIVE.
    Parameters:
      `mappingId` - int
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - List of Document objects in the form of JSON or XML String.
    Since:
      6.2

  - ### getMappingId

    public String getMappingId(String userName, String password, String outputFormat, String projectName, String mappingName)
    Returns the mappingId for the specified mappingName and projectName.outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Specifying the projectName and mappingName are mandatory.
    Parameters:
      `projectName` - String
      `mappingName` - String
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - Mapping Id of the mapping directly under the project.
    Since:
      6.2

  - ### getMappings

    public String getMappings(String userName, String password, String outputFormat, int parentNodeId, String nodeType)
    Returns List of Mappings for the specified parentNodeId, nodeType. Specification of parentNodeId and nodeType are mandatory.outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    If the nodeType is MM_PROJECT parentNodeId will be projectId and if nodeType is MM_SUBJECT then parentNodeId will be subjectId.
    Parameters:
      `parentNodeId` - int
      `nodeType` - Node
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - List of mappings in the form of JSON or XML String.
    Since:
      6.2

  - ### updateMapping

    public String updateMapping(String userName, String password, String outputFormat, String mmMappingObjJson)
    Updates mapping for the specified Mapping Object. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    All the details pertaining to mapping can be updated except the mappingName.The information which needs to be updated should be provided through mapping Object in the form of JSON.
    Specifying valid projectId,mapId and mapingName are mandatory. If Mapping details are updated successfully, RequestStatus.isRequestSuccess() returns true otherwise returns false.
    Parameters:
      `mmMappingObjJson` - JSON format
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Map is updated successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'mmMappingObjJson' JSON :
      {
      "mappingName": "",
      "mappingDescription": "",
      "projectId": 0,
      "mappingId": -1,
      "mappingSubStateName": "",
      "publishNotes": "",
      "subjectId": 0,
      "actualMappingEffortUnits": "",
      "mappingStatus": "",
      "jobXRef": "",
      "userDefined10": "",
      "userDefined11": "",
      "userDefined12": "",
      "updateTargetMetadata": false,
      "updateSourceMetadata": false,
      "userDefined13": "",
      "mappingSpecifications": null,
      "userDefined14": "",
      "userDefined15": "",
      "userDefined16": "",
      "published": false,
      "userDefined17": "",
      "targetUpdateStrategy": "",
      "userDefined18": "",
      "actualETLEffort": 0,
      "userDefined19": "",
      "testDisposition": "",
      "versionLabel": "",
      "plannedETLEffortUnits": "",
      "plannedETLEffort": 0,
      "userDefined8": "",
      "userDefined20": "",
      "userDefined9": "",
      "userDefined21": "",
      "userDefined6": "",
      "userDefined22": "",
      "userDefined7": "",
      "userDefined23": "",
      "userDefined4": "",
      "plannedMappingEffortUnits": "",
      "userDefined5": "",
      "userDefined2": "",
      "userDefined3": "",
      "nodeId": "",
      "userDefined1": "",
      "mappingSubStateId": 0,
      "mappingStateId": 0,
      "changedDescription": "",
      "actualETLEffortUnits": "",
      "userDefined24": "",
      "userDefined25": "",
      "plannedMappingEffort": 0,
      "userDefined26": "",
      "userDefined27": "",
      "userDefined28": "",
      "userDefined29": "",
      "actualDevelopLevelOfEffort": "",
      "actualNotes": "",
      "userDefined30": "",
      "userDefined31": "",
      "testingNotes": "",
      "actualMappingEffort": 0,
      "userDefined32": "",
      "userDefined33": "",
      "sourceExtractQuery": "",
      "userDefined34": "",
      "targetUpgateStrategyNotes": "",
      "plannedDevelopmentLevelOfEffort": "",
      "sourceExtractDescription": "",
      "userDefined35": "",
      "userDefined36": "",
      "userDefined37": "",
      "userDefined38": "",
      "userDefined39": "",
      "mappingStateName": "",
      "userDefined40": "",
      "userDefined41": "",
      "plannedNotes": "",
      "userDefined42": "",
      "userDefined43": "",
      "userDefined44": "",
      "userDefined45": "",
      "mappingDocuments": null,
      "mappingSpecVersion": 1,
      "effectiveDate": null
      }

    Since:
      6.2

  - ### deleteMapping

    public String deleteMapping(String userName, String password, String outputFormat, int mappingId)
    Deletes Mapping for the specified mappingId.outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Specifying mappingId is mandatory to delete a particular mapping.
    Parameters:
      `mappingId` - int
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Map is deleted successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      6.2

  - ### addMappingSpecifications

    public String addMappingSpecifications(String userName, String password, String outputFormat, int mapId, String mmMapSpecRowObjJsonArray)
    Inserts List of mappingSpecifications into the specified mapId.
    Specifying the mapId and List of mappingSpecifications are mandatory,all the mappingSpecifications will get inserted in to the particular mapId.
    Parameters:
      `mapId` - int
      `mmMapSpecRowObjJsonArray` - String
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Mapping specification is added successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'mmMapSpecRowObjJsonArray' JSON :
      [
      {
      "sourceColumnIdentityFlag": false,
      "targetSystemEnvironmentName": "",
      "targetBusinessKeyFlag": false,
      "targetColumnClass": "",
      "userDefined46": "",
      "userDefined47": "",
      "userDefined48": "",
      "userDefined49": "",
      "userDefined50": "",
      "sourcePrimaryKeyFlag": false,
      "targetColumnScale": "",
      "targetColumnAlias": "",
      "sourceSDIFlag": false,
      "targetSDIFlag": false,
      "sourceTableClass": "",
      "sourceColumnAlias": "",
      "sourceColumnScale": "",
      "extendedBusinessRule": "",
      "rowOrder": 0,
      "userDefined8": "",
      "sourceColumnDefinition": "",
      "userDefined9": "",
      "userDefined6": "",
      "userDefined7": "",
      "userDefined4": "",
      "businessRule": "",
      "userDefined5": "",
      "userDefined2": "",
      "userDefined3": "",
      "targetLogicalColumnName": "",
      "userDefined1": "",
      "sourceColumnDatatype": "",
      "sourceSDIDescription": "",
      "targetColumnDefinition": "",
      "sourceSystemEnvironmentName": "",
      "targetSystemName": "",
      "targetColumnComments": "",
      "userDefined24": "",
      "userDefined25": "",
      "userDefined26": "",
      "mappingSpecificationRowComments": "",
      "userDefined27": "",
      "userDefined28": "",
      "userDefined29": "",
      "targetColumnPrecision": "",
      "csmmappingReference": "",
      "targetNaturalKeyFlag": false,
      "userDefined30": "",
      "userDefined31": "",
      "sourceTableAlias": "",
      "userDefined32": "",
      "userDefined33": "",
      "userDefined34": "",
      "targetTableName": "",
      "sourceMinimumValue": "",
      "sourcePercentNullValue": "",
      "sourceSystemId": -1,
      "userDefined35": "",
      "userDefined36": "",
      "userDefined37": "",
      "userDefined38": "",
      "userDefined39": "",
      "sourceLogicalColumnName": "",
      "sourceColumnPrecision": "",
      "sourceMaximumValue": "",
      "userDefined40": "",
      "userDefined41": "",
      "userDefined42": "",
      "pseudocode": "",
      "userDefined43": "",
      "userDefined44": "",
      "userDefined45": "",
      "targetTableAlias": "",
      "baseSourceSystemName": "",
      "sourceTableName": "",
      "mappingSequenceId": 0,
      "userDefined10": "",
      "userDefined11": "",
      "baseSourceSystemEnvironmentName": "",
      "userDefined12": "",
      "targetPrimaryKeyFlag": false,
      "lookupColumn": "",
      "sourceColumnLength": "",
      "sourceBusinessKeyFlag": false,
      "userDefined13": "",
      "sourceNaturalKeyFlag": false,
      "userDefined14": "",
      "userDefined15": "",
      "userDefined16": "",
      "userDefined17": "",
      "targetColumnNullableFlag": false,
      "userDefined18": "",
      "userDefined19": "",
      "lookupOn": "",
      "sourceColumnDBDefaultValue": "",
      "targetColumnLength": "",
      "userDefined20": "",
      "sourceColumnComments": "",
      "userDefined21": "",
      "userDefined22": "",
      "userDefined23": "",
      "sourceSystemName": "",
      "targetSystemId": -1,
      "targetSDIDescription": "",
      "targetTableClass": "",
      "mappingId": 0,
      "specificationArtifacts": "",
      "transformationLookupCondition": "",
      "sourceColumnNullableFlag": false,
      "targetColumnName": "",
      "sourceColumnClass": "",
      "targetColumnETLDefaultValue": "",
      "baseTargetSystemEnvironmentName": "",
      "baseTargetSystemName": "",
      "targetXPath": "",
      "sourceColumnName": "",
      "sourceXPath": "",
      "columnMappingCompleteFlag": false,
      "rdmReferenceTable": "",
      "targetColumnDatatype": "",
      "sourceTableType" : "",
      "targetTableType" : "",
      "sourceEntityUID" : "",
      "targetEntityUID" : "",
      "sourceEnvBusinessEntityType": "",
      "sourceTableBusinessEntityType": "",
      "targetEnvBusinessEntityType": "",
      "targetTableBusinessEntityType": ""
      }
      ]

    Since:
      6.2

  - ### addMappingSpecification

    public String addMappingSpecification(String userName, String password, String outputFormat, int mapId, String mmMapSpecRowObjJson)
    Inserts a single row of mappingSpecification for the specified mapId and mappingSpecificationRow.
    outputFormat can be either Json or XML. If outputFormat is not specified, by default the method will return the Json String.
    Parameters:
      `mapId` - int
      `mmMapSpecRowObjJson` - json String
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Mapping specification row is added successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'mmMapSpecRowObjJson' for this:
      {
      "sourceColumnIdentityFlag": false,
      "targetSystemEnvironmentName": "",
      "targetBusinessKeyFlag": false,
      "targetColumnClass": "",
      "userDefined46": "",
      "userDefined47": "",
      "userDefined48": "",
      "userDefined49": "",
      "userDefined50": "",
      "sourcePrimaryKeyFlag": false,
      "targetColumnScale": "",
      "targetColumnAlias": "",
      "sourceSDIFlag": false,
      "targetSDIFlag": false,
      "sourceTableClass": "",
      "sourceColumnAlias": "",
      "sourceColumnScale": "",
      "extendedBusinessRule": "",
      "rowOrder": 0,
      "userDefined8": "",
      "sourceColumnDefinition": "",
      "userDefined9": "",
      "userDefined6": "",
      "userDefined7": "",
      "userDefined4": "",
      "businessRule": "",
      "userDefined5": "",
      "userDefined2": "",
      "userDefined3": "",
      "targetLogicalColumnName": "",
      "userDefined1": "",
      "sourceColumnDatatype": "",
      "sourceSDIDescription": "",
      "targetColumnDefinition": "",
      "sourceSystemEnvironmentName": "",
      "targetSystemName": "",
      "targetColumnComments": "",
      "userDefined24": "",
      "userDefined25": "",
      "userDefined26": "",
      "mappingSpecificationRowComments": "",
      "userDefined27": "",
      "userDefined28": "",
      "userDefined29": "",
      "targetColumnPrecision": "",
      "csmmappingReference": "",
      "targetNaturalKeyFlag": false,
      "userDefined30": "",
      "userDefined31": "",
      "sourceTableAlias": "",
      "userDefined32": "",
      "userDefined33": "",
      "userDefined34": "",
      "targetTableName": "",
      "sourceMinimumValue": "",
      "sourcePercentNullValue": "",
      "sourceSystemId": -1,
      "userDefined35": "",
      "userDefined36": "",
      "userDefined37": "",
      "userDefined38": "",
      "userDefined39": "",
      "sourceLogicalColumnName": "",
      "sourceColumnPrecision": "",
      "sourceMaximumValue": "",
      "userDefined40": "",
      "userDefined41": "",
      "userDefined42": "",
      "pseudocode": "",
      "userDefined43": "",
      "userDefined44": "",
      "userDefined45": "",
      "targetTableAlias": "",
      "baseSourceSystemName": "",
      "sourceTableName": "",
      "mappingSequenceId": 0,
      "userDefined10": "",
      "userDefined11": "",
      "baseSourceSystemEnvironmentName": "",
      "userDefined12": "",
      "targetPrimaryKeyFlag": false,
      "lookupColumn": "",
      "sourceColumnLength": "",
      "sourceBusinessKeyFlag": false,
      "userDefined13": "",
      "sourceNaturalKeyFlag": false,
      "userDefined14": "",
      "userDefined15": "",
      "userDefined16": "",
      "userDefined17": "",
      "targetColumnNullableFlag": false,
      "userDefined18": "",
      "userDefined19": "",
      "lookupOn": "",
      "sourceColumnDBDefaultValue": "",
      "targetColumnLength": "",
      "userDefined20": "",
      "sourceColumnComments": "",
      "userDefined21": "",
      "userDefined22": "",
      "userDefined23": "",
      "sourceSystemName": "",
      "targetSystemId": -1,
      "targetSDIDescription": "",
      "targetTableClass": "",
      "mappingId": 0,
      "specificationArtifacts": "",
      "transformationLookupCondition": "",
      "sourceColumnNullableFlag": false,
      "targetColumnName": "",
      "sourceColumnClass": "",
      "targetColumnETLDefaultValue": "",
      "baseTargetSystemEnvironmentName": "",
      "baseTargetSystemName": "",
      "targetXPath": "",
      "sourceColumnName": "",
      "sourceXPath": "",
      "columnMappingCompleteFlag": false,
      "rdmReferenceTable": "",
      "targetColumnDatatype": "",
      "sourceTableType" : "",
      "targetTableType" : "",
      "sourceEntityUID" : "",
      "targetEntityUID" : "",
      "sourceEnvBusinessEntityType": "",
      "sourceTableBusinessEntityType": "",
      "targetEnvBusinessEntityType": "",
      "targetTableBusinessEntityType": ""
      }

    Since:
      6.2

  - ### getMappingSpecifications

    public String getMappingSpecifications(String userName, String password, String outputFormat, int mappingId)
    Returns the List of Mapping Specifications for the specified mappingId.outputFormat can be either Json or XML. If outputFormat is not specified, by default the method will return the Json String.
    Specifying the mappingId is mandatory, based on which it returns list of Mapping Specifications associated with it in the form of JSON.
    Parameters:
      `mappingId` - int
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - List of MappingSpecifications in the form of JSON or XML String.
    Since:
      6.2

  - ### deleteMappingSpecifications

    public String deleteMappingSpecifications(String userName, String password, String outputFormat, int mappingId)
    Deletes all the mappingSpecification rows for the specified mappingId.outputFormat can be either Json or XML. If outputFormat is not specified, by default the method will return the Json String. Specifying mappingId is mandatory.
    Parameters:
      `mappingId` - int
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Mapping specification is deleted successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      6.2

  - ### deleteMappingSpecification

    public String deleteMappingSpecification(String userName, String password, String outputFormat, int mappingSequenceId)
    Deletes mappingSpecification for the specified mappingSequenceId.outputFormat can be either Json or XML. If outputFormat is not specified, by default the method will return the Json String.
    Specifying the mappingSequenceId is mandatory.It deletes a particular mappingSpecification row of the mapping based on the mappingSequenceId.
    Parameters:
      `mappingSequenceId` - int
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Mapping specification row is deleted successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      6.2

  - ### baselineProject

    public String baselineProject(String userName, String password, String outputFormat, int projectId, String versionLabel, String changeDescription)
    Appends the baseline to the project for the specified projectId. outputFormat can be either Json or XML. If outputFormat is not specified, by default the method will return the Json String.
    Adds baseline to the project basing the type of versionLabel and specification of the changeDescription which is mandatory.
    Parameters:
      `projectId` - int
      `versionLabel` - String
      `changeDescription` - String
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Project Baseline is created successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      6.2

  - ### versionMapping

    public String versionMapping(String userName, String password, String outputFormat, String mmMappingObjJson)
    Appends mapping version for the specified Mapping Object.outputFormat can be either Json or XML. If outputFormat is not specified, by default the method will return the Json String.
    Appends a new version to the mappings,specifying the changed description is mandatory along with the other details of Mapping Object.
    Parameters:
      `mmMappingObjJson` - in json format
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Map Version is created successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'mmMappingObjJson' JSON :
      {
      "mappingName": "",
      "mappingDescription": "",
      "changedDescription": "",
      "projectId": 0,
      "mappingId": -1,
      "mappingSubStateName": "",
      "publishNotes": "",
      "subjectId": 0,
      "actualMappingEffortUnits": "",
      "mappingStatus": "",
      "jobXRef": "",
      "userDefined10": "",
      "userDefined11": "",
      "userDefined12": "",
      "updateTargetMetadata": false,
      "updateSourceMetadata": false,
      "userDefined13": "",
      "mappingSpecifications": null,
      "userDefined14": "",
      "userDefined15": "",
      "userDefined16": "",
      "published": false,
      "userDefined17": "",
      "targetUpdateStrategy": "",
      "userDefined18": "",
      "actualETLEffort": 0,
      "userDefined19": "",
      "testDisposition": "",
      "versionLabel": "",
      "plannedETLEffortUnits": "",
      "plannedETLEffort": 0,
      "userDefined8": "",
      "userDefined20": "",
      "userDefined9": "",
      "userDefined21": "",
      "userDefined6": "",
      "userDefined22": "",
      "userDefined7": "",
      "userDefined23": "",
      "userDefined4": "",
      "plannedMappingEffortUnits": "",
      "userDefined5": "",
      "userDefined2": "",
      "userDefined3": "",
      "nodeId": "",
      "userDefined1": "",
      "mappingSubStateId": 0,
      "mappingStateId": 0,
      "actualETLEffortUnits": "",
      "userDefined24": "",
      "userDefined25": "",
      "plannedMappingEffort": 0,
      "userDefined26": "",
      "userDefined27": "",
      "userDefined28": "",
      "userDefined29": "",
      "actualDevelopLevelOfEffort": "",
      "actualNotes": "",
      "userDefined30": "",
      "userDefined31": "",
      "testingNotes": "",
      "actualMappingEffort": 0,
      "userDefined32": "",
      "userDefined33": "",
      "sourceExtractQuery": "",
      "userDefined34": "",
      "targetUpgateStrategyNotes": "",
      "plannedDevelopmentLevelOfEffort": "",
      "sourceExtractDescription": "",
      "userDefined35": "",
      "userDefined36": "",
      "userDefined37": "",
      "userDefined38": "",
      "userDefined39": "",
      "mappingStateName": "",
      "userDefined40": "",
      "userDefined41": "",
      "plannedNotes": "",
      "userDefined42": "",
      "userDefined43": "",
      "userDefined44": "",
      "userDefined45": "",
      "mappingDocuments": null,
      "mappingSpecVersion": 0,
      "effectiveDate": null
      }

    Since:
      6.2

  - ### publishMapping

    public String publishMapping(String userName, String password, String outputFormat, int mapId, Date effectiveDate, String changeDescription, String publishNotes)
    Mapping will be published for the specified mapId.
    specifying the mapId, effectiveDate, changed description and publish notes are mandatory along with the other details.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `mapId` - int
      `effectiveDate` - Date -- expected format as YYYY-MM-DD or YYYY-MM-DDTHH:mm:ss
      `changeDescription` - String
      `publishNotes` - String
    Returns:
      String - If Mapping is published successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      7.0

  - ### publishMappingByName

    public String publishMappingByName(String userName, String password, String outputFormat, int nodeId, String nodeType, String mapName, Date effectiveDate, String changeDescription, String publishNotes)
    Mapping will be published for the specified mapName.
    nodeType can be either MM_PROJECT or MM_SUBJECT. Depending on the nodeType, nodeId would be either projectId or SubjectId. Specifying the mapName, effectiveDate, changedDescription and publishNotes are mandatory along with the other details.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String method will return the JSON String.
      `nodeId` - int
      `nodeType` - String - Node Object - valid Types - MM_PROJECT, MM_SUBJECT
      `mapName` - String
      `effectiveDate` - Date -- expected format as YYYY-MM-DD or YYYY-MM-DDTHH:mm:ss
      `changeDescription` - String
      `publishNotes` - String
    Returns:
      String - If Map is published successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      7.0

  - ### addMappingDocument

    public String addMappingDocument(String userName, String password, String outputFormat, int mapId, String document)
    Mapping Document will be added for the specified mapId.
    Specifying the Document Name and either of the Document Object or Document Link and filePathType are mandatory along with the other details.The supported values for the filePathType are ABSOLUTE, RELATIVE.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `mapId` - int
      `document` - String - Document
    Returns:
      String - If Mapping document is added successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'document' JSON :
      {
      "documentIntendedPurpose": "",
      "userData": null,
      "documentReferenceNumber": "",
      "documentType": "",
      "documentName": "",
      "documentApprovedBy": "",
      "documentObject": "",
      "approvalRequired": false,
      "documentOwner": "",
      "documentLink": "",
      "filePathType" : "",
      "documentId": 0,
      "documentReference": "",
      "documentStatus": "",
      "documentApprovedDate": 1460701213000
      }

    Since:
      7.0

  - ### addMappingDocumentByMapName

    public String addMappingDocumentByMapName(String userName, String password, String outputFormat, String nodeType, int nodeId, String mapName, String document)
    Mapping Document will be added for the specified mapName. Specifying the documentName and either of the documentObject or documentLink and filePathType are mandatory along with the other details.The supported values for the filePathType are ABSOLUTE, RELATIVE.
    nodeType can be MM_PROJECT, MM_SUBJECT, MM_MAPPING. Depending upon the nodeType, nodeId would be either projectId or subjectId or mapId.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `nodeId` - int
      `nodeType` - String - Node Object - valid Types - MM_PROJECT, MM_SUBJECT
      `mapName` - String
      `document` - String - Document
    Returns:
      String - If Mapping document is added successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'document' JSON :
      {
      "documentIntendedPurpose": "",
      "userData": null,
      "documentReferenceNumber": "",
      "documentType": "",
      "documentName": "",
      "documentApprovedBy": "",
      "documentObject": "",
      "approvalRequired": false,
      "documentOwner": "",
      "documentLink": "",
      "filePathType" : "",
      "documentId": 0,
      "documentReference": "",
      "documentStatus": "",
      "documentApprovedDate": 1460701213000
      }

    Since:
      7.0

  - ### setMappingLock

    public String setMappingLock(String userName, String password, String outputFormat, int mapId, boolean lockStatus)
    SetMappingLock method either Locks or Unlocks the specified Map. Specifying the mapId and lockStatus are mandatory. lockStatus has values true or false.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `mapId` - int
      `lockStatus` - boolean
    Returns:
      String - If Mapping Lock is changed successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      7.0

  - ### setMappingLockByMapName

    public String setMappingLockByMapName(String userName, String password, String outputFormat, String nodeType, int nodeId, String mapName, boolean lockStatus)
    SetMappingLock method either Locks or Unlocks the specified MapName. Specifying the MapName is mandatory.lockStatus has values true or false.
    nodeType can be MM_PROJECT, MM_SUBJECT. Depending upon the nodeType, nodeId would be either projectId or subjectId.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `nodeId` - int
      `nodeType` - String - Node Object - valid Types - MM_PROJECT, MM_SUBJECT
      `mapName` - String
      `lockStatus` - boolean
    Returns:
      String - If Mapping Lock is changed successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      7.0

  - ### getMapping

    public String getMapping(String userName, String password, String outputFormat, int nodeId, String nodeType, String mapName, float versionNo)
    Returns all the information relating to the specified mapName, such as mappingDescription, mappingSpecVersion, mappingStatus,
    mappingPlannedDevelopmentEffort, actualEffort, testingNotes, versionLabel, userDefined Fields, AuditFields etc...
    Specifying the mapName, nodeId, nodeType and versionNo are mandatory. nodeType can be MM_PROJECT, MM_SUBJECT. Depending upon the nodeType, nodeId would be either projectId, subjectId.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `nodeId` - int
      `nodeType` - Node Object - valid types - MM_PROJECT, MM_SUBJECT
      `mapName` - String
      `versionNo` - int
    Returns:
      String - If Mapping Details are returned successfully, it returns success message otherwise returns failure message.
    Since:
      7.0

  - ### cloneMappingWithNewVersion

    public String cloneMappingWithNewVersion(String userName, String password, String outputFormat, int srcMapId, boolean createNewVersion, String newMapName, String tgtnodeType, int tgtNodeId)
    Clone Mapping creates another copy of the map with newVersion. i.e it copies the map specified at srcMapId and creates another copy at the specified tgtNodeId with newMapName.
    Specifying the srcMapId, newMapName, tgtNodeId, tgtnodeType and createNewVersion are mandatory. createNewVersion has the values true or false.
    If createNewVersion is true then it creates a copy of the map with new version. If createNewVersion is false then it creates a copy of the map with the newMapName specified.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    nodeType can be MM_PROJECT, MM_SUBJECT. Depending upon the nodeType, nodeId would be either projectId, subjectId.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `srcMapId` - int
      `createNewVersion` - Boolean
      `newMapName` - String
      `tgtNodeId` - int
      `tgtnodeType` - String - Node Object - valid Types are MM_PROJECT, MM_SUBJECT
    Returns:
      String - If Mapping is cloned successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      7.0

  - ### cloneMappingByName

    public String cloneMappingByName(String userName, String password, String outputFormat, String srcnodeType, int srcNodeId, String srcMapName, boolean createNewVersion, String newMapName, String tgtnodeType, int tgtNodeId)
    Clone Mapping creates another copy of the map. i.e it copies the map specified at srcNodeId with srcMapName and creates another copy at the specified tgtNodeId.
    Specifying the srcNodeId, srcnodeType, srcMapName, newMapName, tgtNodeId, tgtnodeType and createNewVersion are mandatory. nodeType can be MM_PROJECT, MM_SUBJECT. Depending upon the nodeType , nodeId would be either projectId, subjectId.
    createNewVersion has the values true or false.If createNewVersion is true then it creates a copy of the map with new version. If createNewVersion is false then it creates a copy of the map with the newMapName specified.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `srcNodeId` - int
      `srcnodeType` - String - Node Object - valid Types - MM_PROJECT, MM_SUBJECT
      `srcMapName` - String
      `createNewVersion` - boolean
      `newMapName` - String
      `tgtNodeId` - int
      `tgtnodeType` - String - Node Object - valid Types - MM_PROJECT, MM_SUBJECT
    Returns:
      String - If Mapping is cloned successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      7.0

  - ### mergeMappingByName

    public String mergeMappingByName(String userName, String password, String outputFormat, String srcNodeType, int srcNodeId, String srcMapName, String tgtNodeType, int tgtNodeId, String tgtMapName, boolean createNewVersion, String changeDescription)
    Merge Mapping combines the mapping specifications of one map in to the other map.i.e it copies the map specified at srcNodeId with srcMapName and merges with the map specified at tgtNodeId with the tgtMapName.
    Specifying the srcNodeType, srcNodeId, srcMapName, tgtNodeType, tgtNodeId, tgtMapName are mandatory. createNewVersion has values either true or false. If createNewVersion is true, it creates a new version at tgtNodeId, otherwise it overwrites the mapping. Specifying the change description is mandatory.
    nodeType can be MM_PROJECT, MM_SUBJECT. Depending upon the nodeType, nodeId would be either projectId, subjectId.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `srcNodeId` - int
      `srcNodeType` - String - Node Object - valid Types - MM_PROJECT, MM_SUBJECT
      `srcMapName` - String
      `tgtNodeId` - int
      `tgtNodeType` - String - Node Object - valid Types - MM_PROJECT, MM_SUBJECT
      `tgtMapName` - String
      `createNewVersion` - boolean
      `changeDescription` - String
    Returns:
      String - If Mapping is merged successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      7.0

  - ### mergeMapping

    public String mergeMapping(String userName, String password, String outputFormat, int srcMapId, int tgtMapId, boolean createNewVersion, String changeDescription)
    Merge Mapping combines the mapping specifications of one map in to the other map.I.e it copies the map specified at srcMapId and merges with the map specified at tgtMapId.
    Specifying the srcMapId, tgtMapId are mandatory.
    createNewVersion has values either true or false. If createNewVersion is true, it creates a new version at tgtMapId, otherwise it overwrites the mapping. Specifying the change description is mandatory.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `srcMapId` - int
      `tgtMapId` - int
      `createNewVersion` - boolean
      `changeDescription` - String
    Returns:
      String - If Mapping is merged successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      7.0

  - ### deleteMappingSpecificationsWithMapSeqIds

    public String deleteMappingSpecificationsWithMapSeqIds(String userName, String password, String outputFormat, String mapSeqIdsJsonArray)
    Deletes all mappingSpecification rows for the specified MapSeqIds. Specifying the MapSeqIds are mandatory.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `mapSeqIdsJsonArray` - String - List
    Returns:
      String - If MappingSpecifications are deleted successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      7.0

  - ### deleteMappings

    public String deleteMappings(String userName, String password, String outputFormat, String mappingIdsJsonArray, String versionMode, float versionNo)
    Deletes the mappings of the specified mappingIds. Specifying the mappingIds are mandatory.
    VersionMode has values ALL_VERSIONS, CURRENT_VERSION. ALL_VERSIONS - Deletes all mappings, CURRENT_VERSION - Deletes the present/current version.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `mappingIdsJsonArray` - List
      `versionMode` - String - valid modes - ALL_VERSIONS, CURRENT_VERSION.
      `versionNo` - Float
    Returns:
      String - If mappings are deleted successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      7.0

  - ### deleteMapByName

    public String deleteMapByName(String userName, String password, String outputFormat, String nodeType, int nodeId, String mapName, String versionMode, float versionNo)
    Deletes the map for the specified mapName of the given nodeType and nodeId. Specifying the mapName, nodeType, nodeId are mandatory.
    VersionMode has values ALL_VERSIONS, CURRENT_VERSION, SPECIFIC_VERSION. ALL_VERSIONS - Deletes all mappings, CURRENT_VERSION - Deletes the present/current version. SPECIFIC_VERSION - Deletes a particular version.
    If the versionMode is SPECIFIC_VERSION , specifying the versionNo is mandatory.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `nodeType` - String - Node Object - valid Types - MM_PROJECT, MM_SUBJECT
      `nodeId` - int
      `mapName` - String
      `versionMode` - String - valid modes - ALL_VERSIONS, CURRENT_VERSION.
      `versionNo` - float
    Returns:
      String - If mapping is deleted successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      7.0

  - ### deleteMappingsByNodeType

    public String deleteMappingsByNodeType(String userName, String password, String outputFormat, String nodeType, int nodeId, String versionMode, float versionNo)
    Deletes the mappings of the given nodeType and nodeId. Specifying the nodeType, nodeId are mandatory.
    nodeType can be either MM_PROJECT, MM_SUBJECT. Depending upon the nodeType, nodeId will be either projectId or subjectId.
    VersionMode has values ALL_VERSIONS, CURRENT_VERSION, SPECIFIC_VERSION. ALL_VERSIONS - Deletes all mappings, CURRENT_VERSION - Deletes the present/current version. SPECIFIC_VERSION - Deletes a particular version.
    If the versionMode is SPECIFIC_VERSION , specifying the versionNo is mandatory.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `nodeType` - String - Node Object - valid Types - MM_PROJECT, MM_SUBJECT
      `nodeId` - int
      `versionMode` - String - valid modes - ALL_VERSIONS, CURRENT_VERSION.
      `versionNo` - float
    Returns:
      String - If mappings are deleted successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      7.0

  - ### getMappingSpecificationsWithMapSeqIds

    public String getMappingSpecificationsWithMapSeqIds(String userName, String password, String outputFormat, String mapSeqIdsJsonArray)
    Returns the List of Mapping Specifications for the specified mapSpecIds.
    Specifying the mapSpecIds are mandatory, based on which it returns all the individual maps present in that particular mappings.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `mapSeqIdsJsonArray` - String - List
    Returns:
      String - If MappingSpecifications are returned successfully, it returns success message otherwise returns failure message.
    Since:
      7.0

  - ### updateMappingSpecification

    public String updateMappingSpecification(String userName, String password, String outputFormat, String MappingSpecificationRowObjJson)
    Mapping Specification is updated with the specified MappingSpecificationRow Object. Specifying the mapSequenceId, MapId are mandatory.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `MappingSpecificationRowObjJson` - String - MappingSpecificationRow Object
    Returns:
      String - If MappingSpecification is updated successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'mappingSpecificationRowObjJson' JSON :
      {
      "sourceColumnIdentityFlag": false,
      "targetSystemEnvironmentName": "",
      "targetBusinessKeyFlag": false,
      "targetColumnClass": "",
      "userDefined46": "",
      "userDefined47": "",
      "userDefined48": "",
      "userDefined49": "",
      "userDefined50": "",
      "sourcePrimaryKeyFlag": false,
      "targetColumnScale": "",
      "targetColumnAlias": "",
      "sourceSDIFlag": false,
      "targetSDIFlag": false,
      "sourceTableClass": "",
      "sourceColumnAlias": "",
      "sourceColumnScale": "",
      "extendedBusinessRule": "",
      "rowOrder": 0,
      "userDefined8": "",
      "sourceColumnDefinition": "",
      "userDefined9": "",
      "userDefined6": "",
      "userDefined7": "",
      "userDefined4": "",
      "businessRule": "",
      "userDefined5": "",
      "userDefined2": "",
      "userDefined3": "",
      "targetLogicalColumnName": "",
      "userDefined1": "",
      "sourceColumnDatatype": "",
      "sourceSDIDescription": "",
      "targetColumnDefinition": "",
      "sourceSystemEnvironmentName": "",
      "targetSystemName": "",
      "targetColumnComments": "",
      "userDefined24": "",
      "userDefined25": "",
      "userDefined26": "",
      "mappingSpecificationRowComments": "",
      "userDefined27": "",
      "userDefined28": "",
      "userDefined29": "",
      "targetColumnPrecision": "",
      "csmmappingReference": "",
      "targetNaturalKeyFlag": false,
      "userDefined30": "",
      "userDefined31": "",
      "sourceTableAlias": "",
      "userDefined32": "",
      "userDefined33": "",
      "userDefined34": "",
      "targetTableName": "",
      "sourceMinimumValue": "",
      "sourcePercentNullValue": "",
      "sourceSystemId": -1,
      "userDefined35": "",
      "userDefined36": "",
      "userDefined37": "",
      "userDefined38": "",
      "userDefined39": "",
      "sourceLogicalColumnName": "",
      "sourceColumnPrecision": "",
      "sourceMaximumValue": "",
      "userDefined40": "",
      "userDefined41": "",
      "userDefined42": "",
      "pseudocode": "",
      "userDefined43": "",
      "userDefined44": "",
      "userDefined45": "",
      "targetTableAlias": "",
      "baseSourceSystemName": "",
      "sourceTableName": "",
      "mappingSequenceId": 0,
      "userDefined10": "",
      "userDefined11": "",
      "baseSourceSystemEnvironmentName": "",
      "userDefined12": "",
      "targetPrimaryKeyFlag": false,
      "lookupColumn": "",
      "sourceColumnLength": "",
      "sourceBusinessKeyFlag": false,
      "userDefined13": "",
      "sourceNaturalKeyFlag": false,
      "userDefined14": "",
      "userDefined15": "",
      "userDefined16": "",
      "userDefined17": "",
      "targetColumnNullableFlag": false,
      "userDefined18": "",
      "userDefined19": "",
      "lookupOn": "",
      "sourceColumnDBDefaultValue": "",
      "targetColumnLength": "",
      "userDefined20": "",
      "sourceColumnComments": "",
      "userDefined21": "",
      "userDefined22": "",
      "userDefined23": "",
      "sourceSystemName": "",
      "targetSystemId": -1,
      "targetSDIDescription": "",
      "targetTableClass": "",
      "mappingId": 0,
      "specificationArtifacts": "",
      "transformationLookupCondition": "",
      "sourceColumnNullableFlag": false,
      "targetColumnName": "",
      "sourceColumnClass": "",
      "targetColumnETLDefaultValue": "",
      "baseTargetSystemEnvironmentName": "",
      "baseTargetSystemName": "",
      "targetXPath": "",
      "sourceColumnName": "",
      "sourceXPath": "",
      "columnMappingCompleteFlag": false,
      "rdmReferenceTable": "",
      "targetColumnDatatype": "",
      "sourceTableType" : "",
      "targetTableType" : "",
      "sourceEntityUID" : "",
      "targetEntityUID" : "",
      "sourceEnvBusinessEntityType": "",
      "sourceTableBusinessEntityType": "",
      "targetEnvBusinessEntityType": "",
      "targetTableBusinessEntityType": ""
      }

    Since:
      7.0

  - ### updateMappingSpecifications

    public String updateMappingSpecifications(String userName, String password, String outputFormat, String mappingSpecificationRowJsonArray)
    Mapping Specifications are updated with the specified MappingSpecificationRow Objects. Specifying the mapSequenceIds, MapId are mandatory.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `mappingSpecificationRowJsonArray` - String - MappingSpecificationRow Object
    Returns:
      String - If MappingSpecifications are updated successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'mappingSpecificationRowJsonArray' JSON :
      [
      {
      "sourceColumnIdentityFlag": false,
      "targetSystemEnvironmentName": "",
      "targetBusinessKeyFlag": false,
      "targetColumnClass": "",
      "userDefined46": "",
      "userDefined47": "",
      "userDefined48": "",
      "userDefined49": "",
      "userDefined50": "",
      "sourcePrimaryKeyFlag": false,
      "targetColumnScale": "",
      "targetColumnAlias": "",
      "sourceSDIFlag": false,
      "targetSDIFlag": false,
      "sourceTableClass": "",
      "sourceColumnAlias": "",
      "sourceColumnScale": "",
      "extendedBusinessRule": "",
      "rowOrder": 0,
      "userDefined8": "",
      "sourceColumnDefinition": "",
      "userDefined9": "",
      "userDefined6": "",
      "userDefined7": "",
      "userDefined4": "",
      "businessRule": "",
      "userDefined5": "",
      "userDefined2": "",
      "userDefined3": "",
      "targetLogicalColumnName": "",
      "userDefined1": "",
      "sourceColumnDatatype": "",
      "sourceSDIDescription": "",
      "targetColumnDefinition": "",
      "sourceSystemEnvironmentName": "",
      "targetSystemName": "",
      "targetColumnComments": "",
      "userDefined24": "",
      "userDefined25": "",
      "userDefined26": "",
      "mappingSpecificationRowComments": "",
      "userDefined27": "",
      "userDefined28": "",
      "userDefined29": "",
      "targetColumnPrecision": "",
      "csmmappingReference": "",
      "targetNaturalKeyFlag": false,
      "userDefined30": "",
      "userDefined31": "",
      "sourceTableAlias": "",
      "userDefined32": "",
      "userDefined33": "",
      "userDefined34": "",
      "targetTableName": "",
      "sourceMinimumValue": "",
      "sourcePercentNullValue": "",
      "sourceSystemId": -1,
      "userDefined35": "",
      "userDefined36": "",
      "userDefined37": "",
      "userDefined38": "",
      "userDefined39": "",
      "sourceLogicalColumnName": "",
      "sourceColumnPrecision": "",
      "sourceMaximumValue": "",
      "userDefined40": "",
      "userDefined41": "",
      "userDefined42": "",
      "pseudocode": "",
      "userDefined43": "",
      "userDefined44": "",
      "userDefined45": "",
      "targetTableAlias": "",
      "baseSourceSystemName": "",
      "sourceTableName": "",
      "mappingSequenceId": 0,
      "userDefined10": "",
      "userDefined11": "",
      "baseSourceSystemEnvironmentName": "",
      "userDefined12": "",
      "targetPrimaryKeyFlag": false,
      "lookupColumn": "",
      "sourceColumnLength": "",
      "sourceBusinessKeyFlag": false,
      "userDefined13": "",
      "sourceNaturalKeyFlag": false,
      "userDefined14": "",
      "userDefined15": "",
      "userDefined16": "",
      "userDefined17": "",
      "targetColumnNullableFlag": false,
      "userDefined18": "",
      "userDefined19": "",
      "lookupOn": "",
      "sourceColumnDBDefaultValue": "",
      "targetColumnLength": "",
      "userDefined20": "",
      "sourceColumnComments": "",
      "userDefined21": "",
      "userDefined22": "",
      "userDefined23": "",
      "sourceSystemName": "",
      "targetSystemId": -1,
      "targetSDIDescription": "",
      "targetTableClass": "",
      "mappingId": 0,
      "specificationArtifacts": "",
      "transformationLookupCondition": "",
      "sourceColumnNullableFlag": false,
      "targetColumnName": "",
      "sourceColumnClass": "",
      "targetColumnETLDefaultValue": "",
      "baseTargetSystemEnvironmentName": "",
      "baseTargetSystemName": "",
      "targetXPath": "",
      "sourceColumnName": "",
      "sourceXPath": "",
      "columnMappingCompleteFlag": false,
      "rdmReferenceTable": "",
      "targetColumnDatatype": "",
      "sourceTableType" : "",
      "targetTableType" : "",
      "sourceEntityUID" : "",
      "targetEntityUID" : "",
      "sourceEnvBusinessEntityType": "",
      "sourceTableBusinessEntityType": "",
      "targetEnvBusinessEntityType": "",
      "targetTableBusinessEntityType": ""
      },
      {
      "sourceColumnIdentityFlag": false,
      "targetSystemEnvironmentName": "",
      "targetBusinessKeyFlag": false,
      "targetColumnClass": "",
      "userDefined46": "",
      "userDefined47": "",
      "userDefined48": "",
      "userDefined49": "",
      "userDefined50": "",
      "sourcePrimaryKeyFlag": false,
      "targetColumnScale": "",
      "targetColumnAlias": "",
      "sourceSDIFlag": false,
      "targetSDIFlag": false,
      "sourceTableClass": "",
      "sourceColumnAlias": "",
      "sourceColumnScale": "",
      "extendedBusinessRule": "",
      "rowOrder": 0,
      "userDefined8": "",
      "sourceColumnDefinition": "",
      "userDefined9": "",
      "userDefined6": "",
      "userDefined7": "",
      "userDefined4": "",
      "businessRule": "",
      "userDefined5": "",
      "userDefined2": "",
      "userDefined3": "",
      "targetLogicalColumnName": "",
      "userDefined1": "",
      "sourceColumnDatatype": "",
      "sourceSDIDescription": "",
      "targetColumnDefinition": "",
      "sourceSystemEnvironmentName": "",
      "targetSystemName": "",
      "targetColumnComments": "",
      "userDefined24": "",
      "userDefined25": "",
      "userDefined26": "",
      "mappingSpecificationRowComments": "",
      "userDefined27": "",
      "userDefined28": "",
      "userDefined29": "",
      "targetColumnPrecision": "",
      "csmmappingReference": "",
      "targetNaturalKeyFlag": false,
      "userDefined30": "",
      "userDefined31": "",
      "sourceTableAlias": "",
      "userDefined32": "",
      "userDefined33": "",
      "userDefined34": "",
      "targetTableName": "",
      "sourceMinimumValue": "",
      "sourcePercentNullValue": "",
      "sourceSystemId": -1,
      "userDefined35": "",
      "userDefined36": "",
      "userDefined37": "",
      "userDefined38": "",
      "userDefined39": "",
      "sourceLogicalColumnName": "",
      "sourceColumnPrecision": "",
      "sourceMaximumValue": "",
      "userDefined40": "",
      "userDefined41": "",
      "userDefined42": "",
      "pseudocode": "",
      "userDefined43": "",
      "userDefined44": "",
      "userDefined45": "",
      "targetTableAlias": "",
      "baseSourceSystemName": "",
      "sourceTableName": "",
      "mappingSequenceId": 0,
      "userDefined10": "",
      "userDefined11": "",
      "baseSourceSystemEnvironmentName": "",
      "userDefined12": "",
      "targetPrimaryKeyFlag": false,
      "lookupColumn": "",
      "sourceColumnLength": "",
      "sourceBusinessKeyFlag": false,
      "userDefined13": "",
      "sourceNaturalKeyFlag": false,
      "userDefined14": "",
      "userDefined15": "",
      "userDefined16": "",
      "userDefined17": "",
      "targetColumnNullableFlag": false,
      "userDefined18": "",
      "userDefined19": "",
      "lookupOn": "",
      "sourceColumnDBDefaultValue": "",
      "targetColumnLength": "",
      "userDefined20": "",
      "sourceColumnComments": "",
      "userDefined21": "",
      "userDefined22": "",
      "userDefined23": "",
      "sourceSystemName": "",
      "targetSystemId": -1,
      "targetSDIDescription": "",
      "targetTableClass": "",
      "mappingId": 0,
      "specificationArtifacts": "",
      "transformationLookupCondition": "",
      "sourceColumnNullableFlag": false,
      "targetColumnName": "",
      "sourceColumnClass": "",
      "targetColumnETLDefaultValue": "",
      "baseTargetSystemEnvironmentName": "",
      "baseTargetSystemName": "",
      "targetXPath": "",
      "sourceColumnName": "",
      "sourceXPath": "",
      "columnMappingCompleteFlag": false,
      "rdmReferenceTable": "",
      "targetColumnDatatype": "",
      "sourceTableType" : "",
      "targetTableType" : "",
      "sourceEntityUID" : "",
      "targetEntityUID" : "",
      "sourceEnvBusinessEntityType": "",
      "sourceTableBusinessEntityType": "",
      "targetEnvBusinessEntityType": "",
      "targetTableBusinessEntityType": ""
      }
      ]

    Since:
      7.0

  - ### moveMapping

    public String moveMapping(String userName, String password, String outputFormat, int srcMapId, String tgtnodeType, int tgtNodeId, boolean replaceIfExists, String newMapName)
    Move Mapping moves the map from one node to the other node. i.e It moves the map from specified source location to specified target location. Map specified with srcMapId is moved to tgtNodeId.replaceIfExists has values true or false.
    Specifying the srcMapId, tgtNodeId are mandatory. In the case if the map with srcMapName is already present at tgtNodeId and replaceIfExists has value true, it replaces the map with the srcMapName.
    And if replaceIfExists has value false, it moves to the tgtNodeId with the specified newMapName. Specifying the newMapName is mandatory in case if replaceIfExists has value false.
    nodeType can be MM_PROJECT, MM_SUBJECT. Depending upon the nodeType, nodeId would be either projectId or subjectId.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `srcMapId` - int
      `tgtnodeType` - String - Node Object - valid Types are MM_PROJECT, MM_SUBJECT
      `tgtNodeId` - int
      `replaceIfExists` - boolean
      `newMapName` - String
    Returns:
      String - If Mapping is moved successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      7.0

  - ### moveMappingWithNewMapName

    public String moveMappingWithNewMapName(String userName, String password, String outputFormat, String srcNodeType, int srcNodeId, String srcMapName, String tgtnodeType, int tgtNodeId, boolean replaceIfExists, String newMapName)
    Move Mapping moves the map from one node to the other node. i.e It moves the map from specified source location to specified target location. Map specified with srcMapName at srcNodeId is moved to tgtNodeId. replaceIfExists has values true or false.
    In the case if the map with srcMapName is already present at tgtNodeId and replaceIfExists has value true, it replaces the map with the srcMapName.
    And if replaceIfExists has value false, it moves to the tgtNodeId with the specified newMapName. Specifying the newMapName is mandatory in case if replaceIfExists has value false.
    nodeType can be MM_PROJECT, MM_SUBJECT. Depending upon the nodeType, nodeId would be either projectId, subjectId.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `srcNodeType` - String - Node Object - valid Types are MM_PROJECT, MM_SUBJECT
      `srcNodeId` - int
      `srcMapName` - String
      `tgtnodeType` - String - Node Object - valid Types are MM_PROJECT, MM_SUBJECT
      `tgtNodeId` - int
      `replaceIfExists` - boolean
      `newMapName` - String
    Returns:
      String - If Mapping is moved successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      7.0

  - ### getMappingsWithMapIds

    public String getMappingsWithMapIds(String userName, String password, String outputFormat, String mapIdsJsonArray, boolean fillSpecifications, boolean fillDocuments)
    Returns List of Mappings for the specified List of mapIds. fillSpecifications and fillDocuments have values true or false. Specifying mapIds is mandatory.
    If fillSpecifications and fillDocuments have value true, it returns the list of mappings along with mapping specification details and Documents associated with those mappings.
    If fillSpecifications and fillDocuments have value false, it returns the list of mappings and details associated with those mappings. In this case ,it does not return mapping specification details and Documents associated with those mappings.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `mapIdsJsonArray` - String
      `fillSpecifications` - boolean
      `fillDocuments` - boolean
    Returns:
      String - If Mappings are returned successfully, it returns success message otherwise returns failure message.
    Since:
      7.0

  - ### exportMappingToExcel

    public String exportMappingToExcel(String userName, String password, String outputFormat, int mapId, boolean visibleColumns, boolean includePseudocode)
    Mapping Specification is exported to excel for the specified mapId.Specifying the mapId is mandatory.
    i.e all the mapping specification details such as target details and source details are exported to excel. The exported filePath available in userObject of requestStatus JSON string. The filePath in the returned object is RELATIVE.
    Visible columns has a value either true or false.
    If the Visible Columns is true only the visible columns of mapping specification grid are exported.
    If the Visible Columns is false, then all the columns both visible and hidden from Mapping specification grid are exported to excel.
    If the value of Visible Columns is not specified, by default it takes the value false.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `mapId` - int
      `visibleColumns` - boolean
      `includePseudocode` - boolean
    Returns:
      String - If Export To Excel is successful, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      7.0

  - ### exportMappingToExcelWithMapName

    public String exportMappingToExcelWithMapName(String userName, String password, String outputFormat, String nodeType, int nodeId, String mapName, boolean visibleColumns, boolean includePseudocode)
    Mapping Specification is exported to excel for the specified mapName. Specifying the mapName,nodeType and nodeId are mandatory.
    i.e all the mapping specification details such as target details and source details are exported to excel. The exported filePath available in userObject of requestStatus JSON string. The filePath in the returned object is RELATIVE.
    Visible columns has a value either true or false.
    If the Visible Columns is true only the visible columns of mapping specification grid are exported.
    If the Visible Columns is false, then all the columns both visible and hidden from Mapping specification grid are exported to excel.
    If the value of Visible Columns is not specified, by default it takes the value false.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `nodeType` - String - Node Object - valid Types are MM_PROJECT, MM_SUBJECT
      `nodeId` - int
      `mapName` - String
      `visibleColumns` - Boolean
      `includePseudocode` - Boolean
    Returns:
      String - If Export To Excel is successful, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      7.0

  - ### exportAll

    public String exportAll(String userName, String password, String outputFormat, String nodeType, int nodeId, String selectionCriteria, String exportOption, boolean includePseudoCode, boolean visibleColumns)
    Mapping Specifications are exported to excel for the specified nodeId. nodeType can be either MM_PROJECT, MM_SUBJECT. Depending upon the nodeType, nodeId will be either projectId or subjectId.
    All the mappings of the specified projectId or SubjectId are exported to excel. The exported filePath available in userObject of requestStatus json string. The filePath in the returned object is RELATIVE. Specifying nodeId, nodeType and exportOption are Mandatory.
    selectionCriteria has values ALL, ACTIVE or PASSIVE, By default selectionCriteria takes the value ACTIVE.
    If selectionCriteria value is ALL it exports both ACTIVE and PASSIVE mappings.
    If selectionCriteria value is ACTIVE it exports only ACTIVE mappings.
    If selectionCriteria value is PASSIVE it exports only PASSIVE mappings.
    exportOption has values ExportintMultipleSheet, ExportAll or ExportintoSingleSheet.
    If exportOption value is ExportintMultipleSheet it refers to exporting to single workbook with multiple excelSheets.
    If exportOption value is ExportAll it refers to exporting to individual excel Files.
    If exportOption value is ExportintoSingleSheet it refers to exporting to a single excel Sheet.
    Visible columns has a value either true or false.
    If the Visible Columns is true, only the visible columns of mapping specification grid are exported.
    If the Visible Columns is false, then all the columns both visible and hidden from Mapping specification grid are exported to excel.
    If the value of Visible Columns is not specified, by default it takes the value false.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `nodeType` - String - Node Object - valid Types are MM_PROJECT, MM_SUBJECT
      `nodeId` - int
      `selectionCriteria` - String - ALL, ACTIVE, PASSIVE
      `exportOption` - String - valid Types are ExportintMultipleSheet, ExportAll, ExportintoSingleSheet.
      `includePseudoCode` - Boolean
      `visibleColumns` - Boolean
    Returns:
      String - If Export To Excel is successful, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      7.0

  - ### exportMappingXml

    public String exportMappingXml(String userName, String password, String outputFormat, String nodeType, int nodeId, String selectionCriteria)
    Mapping Specifications are exported to XML for the specified nodeId. Specifying the nodeId, nodeType are mandatory.
    nodeType can be either MM_PROJECT, MM_SUBJECT. Depending upon the nodeType, nodeId will be either projectId or subjectId.
    All the mappings of the specified projectId or SubjectId are exported to XML. The exported filePath available in userObject of requestStatus JSON string. The filePath in the returned object is RELATIVE.
    selectionCriteria has values ALL, ACTIVE or PASSIVE, By default selectionCriteria takes the value ACTIVE.
    If selectionCriteria value is ALL it exports both ACTIVE and PASSIVE mappings.
    If selectionCriteria value is ACTIVE it exports only ACTIVE mappings.
    If selectionCriteria value is PASSIVE it exports only PASSIVE mappings.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `nodeType` - String - Node Object - valid Types are MM_PROJECT, MM_SUBJECT
      `nodeId` - int
      `selectionCriteria` - String - ALL, ACTIVE, PASSIVE
    Returns:
      String - If Export is successful, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      7.0

  - ### unPublishMap

    public String unPublishMap(String userName, String password, String outputFormat, int mapId)
    Mapping is unpublished for the specified mapId. Specifying the mapId is mandatory.
    Once the map is unpublished, it will be removed from published mappings workspace and the map will be a normal map in projects Tree.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `mapId` - int
    Returns:
      String - If Map is unpublished successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      7.0

  - ### unPublishMapByMapName

    public String unPublishMapByMapName(String userName, String password, String outputFormat, String nodeType, int nodeId, String mapName, float versionNo)
    Mapping is unpublished for the specified nodeId.Specifying the nodeId, nodeType are mandatory.
    Once the map is unpublished, it will be removed from published mappings workspace and the map will be a normal map in projects Tree.
    Incase when a particular map is published many times, it creates multiple versions.
    In that case, to delete a particular version, specifying mapName and versionNo are mandatory.
    nodeType can be either MM_PROJECT, MM_SUBJECT. Depending upon the nodeType, nodeId will be either projectId or subjectId.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `nodeType` - String - Node Object - valid Types are MM_PROJECT, MM_SUBJECT
      `nodeId` - int
      `mapName` - String
      `versionNo` - Float
    Returns:
      String - If Map is unpublished successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      7.0

  - ### getProjectsWithDepth

    public String getProjectsWithDepth(String userName, String password, String outputFormat, String depth)
    Returns the projects and its Details according to the specified Depth.
    Specifying the depth is mandatory. Depth has values NAMES, NAMES_IDS, DETAILS, DETAILS_DOCUMENTS, DETAILS_PROJECT_RESOURCES, ALL.
    NAMES - Returns the names of the Projects.
    NAMES_IDS - Returns the names and projectIds.
    DETAILS - Returns the projectDetails.
    DETAILS_DOCUMENTS - Returns the projectDetails and projectDocuments.
    DETAILS_PROJECT_RESOURCES - Returns the projectDetails and projectResources.
    ALL - Returns the projectDetails, projectDocuments and projectResources.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `depth` - String - Node Object - valid depth types are NAMES, NAMES_IDS, DETAILS, DETAILS_DOCUMENTS, DETAILS_PROJECT_RESOURCES, ALL.
    Returns:
      String - If projectDetails are returned successfully, it returns success message otherwise returns failure message.
    Since:
      7.0

  - ### uploadMappingByMapId

    public String uploadMappingByMapId(String userName, String password, String outputFormat, int mapId, String mappingImportHelperJsonObj)
    Uploads the mappingSpecifications on the specified mapId and of the importFileType, importType specified in MappingImportHelper Object.
    Specifying the mapId, importFileType, importType, filePath and filePathType are mandatory. The supported values for the filePathType are ABSOLUTE, RELATIVE.
    Valid importFileType is only MAPPINGMANAGER_EXCEL and importType can be APPEND_TO_EXISTING or DELETE_AND_RELOAD.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `mapId` - int
      `mappingImportHelperJsonObj` - String - mappingImportHelper Object
    Returns:
      String - If uploadMapping is successful, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'mappingImportHelperJsonObj' JSON :
      {
      "filePath": "",
      "filePathType" : "ABSOLUTE",
      "importFileType": "",
      "importType": "",
      "mailComments": null,
      "headerString": "",
      "treatFirstRowAsHeader": false
      }

    Since:
      7.0

  - ### uploadMapping

    public String uploadMapping(String userName, String password, String outputFormat, int nodeId, String nodeType, String mappingImportHelperJsonObj)
    Uploads the mappingSpecifications on the specified nodeId, nodeType and of the importFileType, importType, filePath and filePathType specified in MappingImportHelper Object.
    Specifying the nodeId, nodeType, importFileType, importType, filePath and filePathType are mandatory. The supported values for the filePathType are ABSOLUTE, RELATIVE.
    Valid importFileTypes are MAPPINGMANAGER_LEGACY_EXCEL, MAPPINGMANAGER_XML, INFORMATICA, DATASTAGE, SSIS_2008 and importType can be APPEND_TO_EXISTING or DELETE_AND_RELOAD.
    nodeType can be either MM_PROJECT, MM_SUBJECT. Depending upon the nodeType, nodeId will be either projectId or subjectId.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `nodeId` - int
      `nodeType` - String - Node Object - valid Types are MM_PROJECT, MM_SUBJECT
      `mappingImportHelperJsonObj` - String - mappingImportHelper Object
    Returns:
      String - If uploadMapping is successful, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'mappingImportHelperJsonObj' JSON :
      {
      "filePath": "",
      "filePathType" : "ABSOLUTE",
      "importFileType": "",
      "importType": "",
      "mailComments": null,
      "headerString": "",
      "treatFirstRowAsHeader": false
      }

    Since:
      7.0

  - ### deleteMappingSpecificationRow

    public String deleteMappingSpecificationRow(String userName, String password, String outputFormat, String mappingSpecificationRowJsonObj)
    Deletes the mappingSpecificationRow for the specified mappingSpecificationRow Object.
    Specifying the mappingSequenceId and mapId are mandatory.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `mappingSpecificationRowJsonObj` - String - mappingSpecificationRow Object
    Returns:
      String - If delete is successful, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'mappingSpecificationRowJsonObj' JSON :
      {
      "mappingId":0,
      "mappingSequenceId":0 }

    Since:
      7.0

  - ### deleteMappingSpecificationRows

    public String deleteMappingSpecificationRows(String userName, String password, String outputFormat, String mappingSpecificationRowsJsonArray)
    Deletes the mappingSpecifications for the specified List of mappingSpecificationRows.
    Specifying the mappingSequenceIds and mapId are mandatory.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `mappingSpecificationRowsJsonArray` - String - List of mappingSpecificationRows
    Returns:
      String - If deletion of mappingSpecificationRows are successful, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'mappingSpecificationRowsJsonArray' JSON :
      [{
      "mappingId":0,
      "mappingSequenceId":0 },
      {
      "mappingId":0,
      "mappingSequenceId":0 }]

    Since:
      7.0

  - ### deleteMappingsByListOfMapNames

    public String deleteMappingsByListOfMapNames(String userName, String password, String outputFormat, String nodeType, int nodeId, String mapNamesJsonArray, String versionMode, float versionNo)
    Deletes the mappings of the specified List of mapNames of the given nodeType and nodeId.
    Specifying the mapNames, nodeType, nodeId, versionMode are mandatory.
    VersionMode has values ALL_VERSIONS, CURRENT_VERSION, SPECIFIC_VERSION.
    ALL_VERSIONS - Deletes all mappings.
    CURRENT_VERSION - Deletes the present/current version.
    SPECIFIC_VERSION - Deletes a particular version.
    If the versionMode is SPECIFIC_VERSION , specifying the versionNo is mandatory.
    nodeType can be either MM_PROJECT, MM_SUBJECT. Depending upon the nodeType, nodeId will be either projectId or subjectId.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `nodeType` - String - MM_PROJECT, MM_SUBJECT
      `nodeId` - int
      `mapNamesJsonArray` - String - List of mapNames
      `versionMode` - String - APIConstants Object - valid modes - ALL_VERSIONS, CURRENT_VERSION, SPECIFIC_VERSION.
      `versionNo` - float
    Returns:
      String - If deletion of mappings is successful, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      7.0

  - ### deleteMappingByMapId

    public String deleteMappingByMapId(String userName, String password, String outputFormat, int mapId, String versionMode, float versionNo)
    Deletes the mapping of the specified mapId, versionMode. Specifying the mapId, versionMode are mandatory.
    VersionMode has values ALL_VERSIONS, CURRENT_VERSION, SPECIFIC_VERSION.
    ALL_VERSIONS - Deletes all mappings.
    CURRENT_VERSION - Deletes the present/current version.
    SPECIFIC_VERSION - Deletes a particular version.
    If the versionMode is SPECIFIC_VERSION , specifying the versionNo is mandatory.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `mapId` - int
      `versionMode` - String - APIConstants Object - valid modes - ALL_VERSIONS, CURRENT_VERSION, SPECIFIC_VERSION.
      `versionNo` - float
    Returns:
      String - If deletion of mapping is successful, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      7.0

  - ### createSubjectByName

    public String createSubjectByName(String userName, String password, String outputFormat, int projectId, int parentSubjectId, String subjectName)
    Creates Subject for the specified ProjectId, ParentSubjectId, SubjectName. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Specifying projectId,subjectName are Mandatory to create a subject.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `projectId` - int
      `parentSubjectId` - int
      `subjectName` - String
    Returns:
      String - If Subject is added successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      8.1

  - ### createSubjectWithDescription

    public String createSubjectWithDescription(String userName, String password, String outputFormat, int projectId, int parentSubjectId, String subjectName, String subjectDescription)
    Creates Subject for the specified ProjectId, ParentSubjectId, SubjectName and SubjectDescription. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Specifying projectId , subjectName are Mandatory to create a subject.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `projectId` - int
      `parentSubjectId` - int
      `subjectName` - String
      `subjectDescription` - String
    Returns:
      String - If Subject is added successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      8.1

  - ### publishMappings

    public String publishMappings(String userName, String password, String outputFormat, String mapIdsJsonArray, Date effectiveDate, String changeDescription, String publishNotes)
    Mappings will be published for the specified mapIds in the JSON.
    specifying the mapIds, effectiveDate, changed description and publish notes are mandatory along with the other details.
    outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - - Valid values: JSON or XML
      `mapIdsJsonArray` - String
      `effectiveDate` - -- expected format as YYYY-MM-DD or YYYY-MM-DDTHH:mm:ss
      `changeDescription` - String
      `publishNotes` - String
    Returns:
      String - If Mappings are published successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      8.3

  - ### createMappings

    public String createMappings(String userName, String password, String outputFormat, String mappings, boolean addSpecifications)
    Creates Mappings for the specified mapping objects,addSpecifications and outputFormat. outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Specifying projectId and mappingName are mandatory. If the value of addSpecifications is true, mappings gets created with all the specification details provided.If the value of addSpecifications is false only empty mappings with out any specifications gets created.
    Parameters:
      `mappings` - String
      `addSpecifications` - Boolean
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If Mappings are added successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'mappings' JSON :
      [
      {
      "projectId": 0,
      "mappingName": "",
      "mappingId": 0,
      "mappingSubStateName": null,
      "publishNotes": null,
      "subjectId": -1,
      "actualMappingEffortUnits": "",
      "mappingStatus": "",
      "jobXRef": "",
      "userDefined10": "",
      "userDefined11": "",
      "userDefined12": "",
      "updateTargetMetadata": false,
      "updateSourceMetadata": false,
      "userDefined13": "",
      "mappingSpecifications": [
      {
      "sourceColumnIdentityFlag": false,
      "targetSystemEnvironmentName": "",
      "targetBusinessKeyFlag": false,
      "targetColumnClass": "",
      "userDefined46": "",
      "userDefined47": "",
      "userDefined48": "",
      "userDefined49": "",
      "userDefined50": "",
      "sourcePrimaryKeyFlag": false,
      "targetColumnScale": "",
      "targetColumnAlias": "",
      "sourceSDIFlag": false,
      "targetSDIFlag": false,
      "sourceTableClass": "",
      "sourceColumnAlias": "",
      "sourceColumnScale": "",
      "extendedBusinessRule": "",
      "rowOrder": 1,
      "userDefined8": "",
      "sourceColumnDefinition": "",
      "userDefined9": "",
      "userDefined6": "",
      "userDefined7": "",
      "userDefined4": "",
      "businessRule": "",
      "userDefined5": "",
      "userDefined2": "",
      "userDefined3": "",
      "targetLogicalColumnName": "",
      "userDefined1": "",
      "sourceColumnDatatype": "",
      "sourceSDIDescription": "",
      "targetColumnDefinition": "",
      "sourceSystemEnvironmentName": "",
      "targetSystemName": "",
      "targetColumnComments": "",
      "userDefined24": "",
      "userDefined25": "",
      "userDefined26": "",
      "mappingSpecificationRowComments": "",
      "userDefined27": "",
      "userDefined28": "",
      "userDefined29": "",
      "targetColumnPrecision": "",
      "csmmappingReference": "",
      "targetNaturalKeyFlag": false,
      "userDefined30": "",
      "userDefined31": "",
      "sourceTableAlias": "",
      "userDefined32": "",
      "userDefined33": "",
      "userDefined34": "",
      "targetTableName": "",
      "sourceMinimumValue": "",
      "sourcePercentNullValue": "",
      "sourceSystemId": -1,
      "userDefined35": "",
      "userDefined36": "",
      "userDefined37": "",
      "userDefined38": "",
      "userDefined39": "",
      "sourceLogicalColumnName": "",
      "sourceColumnPrecision": "",
      "sourceMaximumValue": "",
      "userDefined40": "",
      "userDefined41": "",
      "userDefined42": "",
      "pseudocode": "",
      "userDefined43": "",
      "userDefined44": "",
      "userDefined45": "",
      "targetTableAlias": "",
      "baseSourceSystemName": "",
      "sourceTableName": "",
      "mappingSequenceId": 0,
      "userDefined10": "",
      "userDefined11": "",
      "baseSourceSystemEnvironmentName": "",
      "userDefined12": "",
      "targetPrimaryKeyFlag": false,
      "lookupColumn": "",
      "sourceColumnLength": "",
      "sourceBusinessKeyFlag": false,
      "userDefined13": "",
      "sourceNaturalKeyFlag": false,
      "userDefined14": "",
      "userDefined15": "",
      "userDefined16": "",
      "userDefined17": "",
      "targetColumnNullableFlag": false,
      "userDefined18": "",
      "userDefined19": "",
      "lookupOn": "",
      "sourceColumnDBDefaultValue": "",
      "targetColumnLength": "",
      "userDefined20": "",
      "sourceColumnComments": "",
      "userDefined21": "",
      "userDefined22": "",
      "userDefined23": "",
      "sourceSystemName": "",
      "targetSystemId": -1,
      "targetSDIDescription": "",
      "targetTableClass": "",
      "mappingId": 1,
      "specificationArtifacts": "",
      "transformationLookupCondition": "",
      "sourceColumnNullableFlag": false,
      "targetColumnName": "",
      "sourceColumnClass": "",
      "targetColumnETLDefaultValue": "",
      "baseTargetSystemEnvironmentName": "",
      "baseTargetSystemName": "",
      "targetXPath": "",
      "sourceColumnName": "",
      "sourceXPath": "",
      "columnMappingCompleteFlag": false,
      "rdmReferenceTable": "",
      "targetColumnDatatype": "",
      "sourceTableType" : "",
      "targetTableType" : "",
      "sourceEntityUID" : "",
      "targetEntityUID" : "",
      "sourceEnvBusinessEntityType": "",
      "sourceTableBusinessEntityType": "",
      "targetEnvBusinessEntityType": "",
      "targetTableBusinessEntityType": ""
      }
      ],
      "userDefined14": "",
      "userDefined15": "",
      "userDefined16": "",
      "published": false,
      "userDefined17": "",
      "targetUpdateStrategy": "",
      "userDefined18": "",
      "actualETLEffort": 0,
      "userDefined19": "",
      "testDisposition": " ",
      "versionLabel": "",
      "plannedETLEffortUnits": "",
      "plannedETLEffort": 0,
      "userDefined8": "",
      "userDefined20": "",
      "userDefined9": "",
      "userDefined21": "",
      "userDefined6": "",
      "userDefined22": "",
      "userDefined7": "",
      "userDefined23": "",
      "userDefined4": "",
      "plannedMappingEffortUnits": "",
      "userDefined5": "",
      "userDefined2": "",
      "userDefined3": "",
      "nodeId": "",
      "userDefined1": "",
      "mappingSubStateId": 0,
      "mappingStateId": 0,
      "changedDescription": "",
      "actualETLEffortUnits": "",
      "userDefined24": "",
      "userDefined25": "",
      "plannedMappingEffort": 0,
      "userDefined26": "",
      "userDefined27": "",
      "userDefined28": "",
      "userDefined29": "",
      "actualDevelopLevelOfEffort": null,
      "actualNotes": "",
      "userDefined30": "",
      "userDefined31": "",
      "testingNotes": "",
      "actualMappingEffort": 0,
      "userDefined32": "",
      "userDefined33": "",
      "sourceExtractQuery": "",
      "userDefined34": "",
      "targetUpgateStrategyNotes": "",
      "plannedDevelopmentLevelOfEffort": null,
      "sourceExtractDescription": "",
      "userDefined35": "",
      "mappingDescription": "",
      "userDefined36": "",
      "userDefined37": "",
      "userDefined38": "",
      "userDefined39": "",
      "mappingStateName": null,
      "userDefined40": "",
      "userDefined41": "",
      "plannedNotes": "",
      "userDefined42": "",
      "userDefined43": "",
      "userDefined44": "",
      "userDefined45": "",
      "mappingDocuments": null,
      "mappingSpecVersion": 0,
      "effectiveDate": null
      },
      {
      "projectId": 0,
      "mappingName": "",
      "mappingId": 0,
      "mappingSubStateName": null,
      "publishNotes": null,
      "subjectId": -1,
      "actualMappingEffortUnits": "",
      "mappingStatus": "",
      "jobXRef": "",
      "userDefined10": "",
      "userDefined11": "",
      "userDefined12": "",
      "updateTargetMetadata": false,
      "updateSourceMetadata": false,
      "userDefined13": "",
      "mappingSpecifications": [
      {
      "sourceColumnIdentityFlag": false,
      "targetSystemEnvironmentName": "",
      "targetBusinessKeyFlag": false,
      "targetColumnClass": "",
      "userDefined46": "",
      "userDefined47": "",
      "userDefined48": "",
      "userDefined49": "",
      "userDefined50": "",
      "sourcePrimaryKeyFlag": false,
      "targetColumnScale": "",
      "targetColumnAlias": "",
      "sourceSDIFlag": false,
      "targetSDIFlag": false,
      "sourceTableClass": "",
      "sourceColumnAlias": "",
      "sourceColumnScale": "",
      "extendedBusinessRule": "",
      "rowOrder": 1,
      "userDefined8": "",
      "sourceColumnDefinition": "",
      "userDefined9": "",
      "userDefined6": "",
      "userDefined7": "",
      "userDefined4": "",
      "businessRule": "",
      "userDefined5": "",
      "userDefined2": "",
      "userDefined3": "",
      "targetLogicalColumnName": "",
      "userDefined1": "",
      "sourceColumnDatatype": "",
      "sourceSDIDescription": "",
      "targetColumnDefinition": "",
      "sourceSystemEnvironmentName": "",
      "targetSystemName": "",
      "targetColumnComments": "",
      "userDefined24": "",
      "userDefined25": "",
      "userDefined26": "",
      "mappingSpecificationRowComments": "",
      "userDefined27": "",
      "userDefined28": "",
      "userDefined29": "",
      "targetColumnPrecision": "",
      "csmmappingReference": "",
      "targetNaturalKeyFlag": false,
      "userDefined30": "",
      "userDefined31": "",
      "sourceTableAlias": "",
      "userDefined32": "",
      "userDefined33": "",
      "userDefined34": "",
      "targetTableName": "",
      "sourceMinimumValue": "",
      "sourcePercentNullValue": "",
      "sourceSystemId": -1,
      "userDefined35": "",
      "userDefined36": "",
      "userDefined37": "",
      "userDefined38": "",
      "userDefined39": "",
      "sourceLogicalColumnName": "",
      "sourceColumnPrecision": "",
      "sourceMaximumValue": "",
      "userDefined40": "",
      "userDefined41": "",
      "userDefined42": "",
      "pseudocode": "",
      "userDefined43": "",
      "userDefined44": "",
      "userDefined45": "",
      "targetTableAlias": "",
      "baseSourceSystemName": "",
      "sourceTableName": "",
      "mappingSequenceId": 0,
      "userDefined10": "",
      "userDefined11": "",
      "baseSourceSystemEnvironmentName": "",
      "userDefined12": "",
      "targetPrimaryKeyFlag": false,
      "lookupColumn": "",
      "sourceColumnLength": "",
      "sourceBusinessKeyFlag": false,
      "userDefined13": "",
      "sourceNaturalKeyFlag": false,
      "userDefined14": "",
      "userDefined15": "",
      "userDefined16": "",
      "userDefined17": "",
      "targetColumnNullableFlag": false,
      "userDefined18": "",
      "userDefined19": "",
      "lookupOn": "",
      "sourceColumnDBDefaultValue": "",
      "targetColumnLength": "",
      "userDefined20": "",
      "sourceColumnComments": "",
      "userDefined21": "",
      "userDefined22": "",
      "userDefined23": "",
      "sourceSystemName": "",
      "targetSystemId": -1,
      "targetSDIDescription": "",
      "targetTableClass": "",
      "mappingId": 1,
      "specificationArtifacts": "",
      "transformationLookupCondition": "",
      "sourceColumnNullableFlag": false,
      "targetColumnName": "",
      "sourceColumnClass": "",
      "targetColumnETLDefaultValue": "",
      "baseTargetSystemEnvironmentName": "",
      "baseTargetSystemName": "",
      "targetXPath": "",
      "sourceColumnName": "",
      "sourceXPath": "",
      "columnMappingCompleteFlag": false,
      "rdmReferenceTable": "",
      "targetColumnDatatype": "",
      "sourceTableType" : "",
      "targetTableType" : "",
      "sourceEntityUID" : "",
      "targetEntityUID" : "",
      "sourceEnvBusinessEntityType": "",
      "sourceTableBusinessEntityType": "",
      "targetEnvBusinessEntityType": "",
      "targetTableBusinessEntityType": ""
      }
      ],
      "userDefined14": "",
      "userDefined15": "",
      "userDefined16": "",
      "published": false,
      "userDefined17": "",
      "targetUpdateStrategy": "",
      "userDefined18": "",
      "actualETLEffort": 0,
      "userDefined19": "",
      "testDisposition": " ",
      "versionLabel": "",
      "plannedETLEffortUnits": "",
      "plannedETLEffort": 0,
      "userDefined8": "",
      "userDefined20": "",
      "userDefined9": "",
      "userDefined21": "",
      "userDefined6": "",
      "userDefined22": "",
      "userDefined7": "",
      "userDefined23": "",
      "userDefined4": "",
      "plannedMappingEffortUnits": "",
      "userDefined5": "",
      "userDefined2": "",
      "userDefined3": "",
      "nodeId": "",
      "userDefined1": "",
      "mappingSubStateId": 0,
      "mappingStateId": 0,
      "changedDescription": "",
      "actualETLEffortUnits": "",
      "userDefined24": "",
      "userDefined25": "",
      "plannedMappingEffort": 0,
      "userDefined26": "",
      "userDefined27": "",
      "userDefined28": "",
      "userDefined29": "",
      "actualDevelopLevelOfEffort": null,
      "actualNotes": "",
      "userDefined30": "",
      "userDefined31": "",
      "testingNotes": "",
      "actualMappingEffort": 0,
      "userDefined32": "",
      "userDefined33": "",
      "sourceExtractQuery": "",
      "userDefined34": "",
      "targetUpgateStrategyNotes": "",
      "plannedDevelopmentLevelOfEffort": null,
      "sourceExtractDescription": "",
      "userDefined35": "",
      "mappingDescription": "",
      "userDefined36": "",
      "userDefined37": "",
      "userDefined38": "",
      "userDefined39": "",
      "mappingStateName": null,
      "userDefined40": "",
      "userDefined41": "",
      "plannedNotes": "",
      "userDefined42": "",
      "userDefined43": "",
      "userDefined44": "",
      "userDefined45": "",
      "mappingDocuments": null,
      "mappingSpecVersion": 0,
      "effectiveDate": null
      }
      ]

    Since:
      10.2

  - ### createMappingsWithFillOptions

    public String createMappingsWithFillOptions(String userName, String password, String outputFormat, String mappings, int fillOptions)
    Creates Mappings for the specified mapping objects and fillOptions. OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Specifying projectId and mappingName are mandatory in each mapping object.
    Here fillOptions can be Integer values of either `APIConstants.MMFillOptions.MAPPING_SPECIFICATIONS` or `APIConstants.MMFillOptions.MAPPING_DOCUMENTS` or `APIConstants.MMFillOptions.MAPPING_EXTENDED_PROPERTIES` for example: If you want to add mappings along with mapping specifications and documents you need to pass the fillOptions parameter value as 3 (MAPPING_SPECIFICATIONS(1) + MAPPING_DOCUMENTS(2)).
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `mappings` - String
      `fillOptions` - `APIConstants.MMFillOptions` int
    Returns:
      String - If Mappings are added successfully, it will return RequestStatus Object consisting of Request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'mappings' JSON :
      [
      {
      "projectId": 0,
      "mappingName": "",
      "mappingId": 0,
      "mappingSubStateName": null,
      "publishNotes": null,
      "subjectId": -1,
      "actualMappingEffortUnits": "",
      "mappingStatus": "",
      "jobXRef": "",
      "userDefined10": "",
      "userDefined11": "",
      "userDefined12": "",
      "updateTargetMetadata": false,
      "updateSourceMetadata": false,
      "userDefined13": "",
      "mappingSpecifications": [
      {
      "sourceColumnIdentityFlag": false,
      "targetSystemEnvironmentName": "",
      "targetBusinessKeyFlag": false,
      "targetColumnClass": "",
      "userDefined46": "",
      "userDefined47": "",
      "userDefined48": "",
      "userDefined49": "",
      "userDefined50": "",
      "sourcePrimaryKeyFlag": false,
      "targetColumnScale": "",
      "targetColumnAlias": "",
      "sourceSDIFlag": false,
      "targetSDIFlag": false,
      "sourceTableClass": "",
      "sourceColumnAlias": "",
      "sourceColumnScale": "",
      "extendedBusinessRule": "",
      "rowOrder": 1,
      "userDefined8": "",
      "sourceColumnDefinition": "",
      "userDefined9": "",
      "userDefined6": "",
      "userDefined7": "",
      "userDefined4": "",
      "businessRule": "",
      "userDefined5": "",
      "userDefined2": "",
      "userDefined3": "",
      "targetLogicalColumnName": "",
      "userDefined1": "",
      "sourceColumnDatatype": "",
      "sourceSDIDescription": "",
      "targetColumnDefinition": "",
      "sourceSystemEnvironmentName": "",
      "targetSystemName": "",
      "targetColumnComments": "",
      "userDefined24": "",
      "userDefined25": "",
      "userDefined26": "",
      "mappingSpecificationRowComments": "",
      "userDefined27": "",
      "userDefined28": "",
      "userDefined29": "",
      "targetColumnPrecision": "",
      "csmmappingReference": "",
      "targetNaturalKeyFlag": false,
      "userDefined30": "",
      "userDefined31": "",
      "sourceTableAlias": "",
      "userDefined32": "",
      "userDefined33": "",
      "userDefined34": "",
      "targetTableName": "",
      "sourceMinimumValue": "",
      "sourcePercentNullValue": "",
      "sourceSystemId": -1,
      "userDefined35": "",
      "userDefined36": "",
      "userDefined37": "",
      "userDefined38": "",
      "userDefined39": "",
      "sourceLogicalColumnName": "",
      "sourceColumnPrecision": "",
      "sourceMaximumValue": "",
      "userDefined40": "",
      "userDefined41": "",
      "userDefined42": "",
      "pseudocode": "",
      "userDefined43": "",
      "userDefined44": "",
      "userDefined45": "",
      "targetTableAlias": "",
      "baseSourceSystemName": "",
      "sourceTableName": "",
      "mappingSequenceId": 0,
      "userDefined10": "",
      "userDefined11": "",
      "baseSourceSystemEnvironmentName": "",
      "userDefined12": "",
      "targetPrimaryKeyFlag": false,
      "lookupColumn": "",
      "sourceColumnLength": "",
      "sourceBusinessKeyFlag": false,
      "userDefined13": "",
      "sourceNaturalKeyFlag": false,
      "userDefined14": "",
      "userDefined15": "",
      "userDefined16": "",
      "userDefined17": "",
      "targetColumnNullableFlag": false,
      "userDefined18": "",
      "userDefined19": "",
      "lookupOn": "",
      "sourceColumnDBDefaultValue": "",
      "targetColumnLength": "",
      "userDefined20": "",
      "sourceColumnComments": "",
      "userDefined21": "",
      "userDefined22": "",
      "userDefined23": "",
      "sourceSystemName": "",
      "targetSystemId": -1,
      "targetSDIDescription": "",
      "targetTableClass": "",
      "mappingId": 1,
      "specificationArtifacts": "",
      "transformationLookupCondition": "",
      "sourceColumnNullableFlag": false,
      "targetColumnName": "",
      "sourceColumnClass": "",
      "targetColumnETLDefaultValue": "",
      "baseTargetSystemEnvironmentName": "",
      "baseTargetSystemName": "",
      "targetXPath": "",
      "sourceColumnName": "",
      "sourceXPath": "",
      "columnMappingCompleteFlag": false,
      "rdmReferenceTable": "",
      "targetColumnDatatype": "",
      "sourceTableType" : "",
      "targetTableType" : "",
      "sourceEntityUID" : "",
      "targetEntityUID" : "",
      "sourceEnvBusinessEntityType": "",
      "sourceTableBusinessEntityType": "",
      "targetEnvBusinessEntityType": "",
      "targetTableBusinessEntityType": ""
      }
      ],
      "userDefined14": "",
      "userDefined15": "",
      "userDefined16": "",
      "published": false,
      "userDefined17": "",
      "targetUpdateStrategy": "",
      "userDefined18": "",
      "actualETLEffort": 0,
      "userDefined19": "",
      "testDisposition": " ",
      "versionLabel": "",
      "plannedETLEffortUnits": "",
      "plannedETLEffort": 0,
      "userDefined8": "",
      "userDefined20": "",
      "userDefined9": "",
      "userDefined21": "",
      "userDefined6": "",
      "userDefined22": "",
      "userDefined7": "",
      "userDefined23": "",
      "userDefined4": "",
      "plannedMappingEffortUnits": "",
      "userDefined5": "",
      "userDefined2": "",
      "userDefined3": "",
      "nodeId": "",
      "userDefined1": "",
      "mappingSubStateId": 0,
      "mappingStateId": 0,
      "changedDescription": "",
      "actualETLEffortUnits": "",
      "userDefined24": "",
      "userDefined25": "",
      "plannedMappingEffort": 0,
      "userDefined26": "",
      "userDefined27": "",
      "userDefined28": "",
      "userDefined29": "",
      "actualDevelopLevelOfEffort": null,
      "actualNotes": "",
      "userDefined30": "",
      "userDefined31": "",
      "testingNotes": "",
      "actualMappingEffort": 0,
      "userDefined32": "",
      "userDefined33": "",
      "sourceExtractQuery": "",
      "userDefined34": "",
      "targetUpgateStrategyNotes": "",
      "plannedDevelopmentLevelOfEffort": null,
      "sourceExtractDescription": "",
      "userDefined35": "",
      "mappingDescription": "",
      "userDefined36": "",
      "userDefined37": "",
      "userDefined38": "",
      "userDefined39": "",
      "mappingStateName": null,
      "userDefined40": "",
      "userDefined41": "",
      "plannedNotes": "",
      "userDefined42": "",
      "userDefined43": "",
      "userDefined44": "",
      "userDefined45": "",
      "mappingDocuments": null,
      "mappingSpecVersion": 0,
      "effectiveDate": null
      },
      {
      "projectId": 0,
      "mappingName": "",
      "mappingId": 0,
      "mappingSubStateName": null,
      "publishNotes": null,
      "subjectId": -1,
      "actualMappingEffortUnits": "",
      "mappingStatus": "",
      "jobXRef": "",
      "userDefined10": "",
      "userDefined11": "",
      "userDefined12": "",
      "updateTargetMetadata": false,
      "updateSourceMetadata": false,
      "userDefined13": "",
      "mappingSpecifications": [
      {
      "sourceColumnIdentityFlag": false,
      "targetSystemEnvironmentName": "",
      "targetBusinessKeyFlag": false,
      "targetColumnClass": "",
      "userDefined46": "",
      "userDefined47": "",
      "userDefined48": "",
      "userDefined49": "",
      "userDefined50": "",
      "sourcePrimaryKeyFlag": false,
      "targetColumnScale": "",
      "targetColumnAlias": "",
      "sourceSDIFlag": false,
      "targetSDIFlag": false,
      "sourceTableClass": "",
      "sourceColumnAlias": "",
      "sourceColumnScale": "",
      "extendedBusinessRule": "",
      "rowOrder": 1,
      "userDefined8": "",
      "sourceColumnDefinition": "",
      "userDefined9": "",
      "userDefined6": "",
      "userDefined7": "",
      "userDefined4": "",
      "businessRule": "",
      "userDefined5": "",
      "userDefined2": "",
      "userDefined3": "",
      "targetLogicalColumnName": "",
      "userDefined1": "",
      "sourceColumnDatatype": "",
      "sourceSDIDescription": "",
      "targetColumnDefinition": "",
      "sourceSystemEnvironmentName": "",
      "targetSystemName": "",
      "targetColumnComments": "",
      "userDefined24": "",
      "userDefined25": "",
      "userDefined26": "",
      "mappingSpecificationRowComments": "",
      "userDefined27": "",
      "userDefined28": "",
      "userDefined29": "",
      "targetColumnPrecision": "",
      "csmmappingReference": "",
      "targetNaturalKeyFlag": false,
      "userDefined30": "",
      "userDefined31": "",
      "sourceTableAlias": "",
      "userDefined32": "",
      "userDefined33": "",
      "userDefined34": "",
      "targetTableName": "",
      "sourceMinimumValue": "",
      "sourcePercentNullValue": "",
      "sourceSystemId": -1,
      "userDefined35": "",
      "userDefined36": "",
      "userDefined37": "",
      "userDefined38": "",
      "userDefined39": "",
      "sourceLogicalColumnName": "",
      "sourceColumnPrecision": "",
      "sourceMaximumValue": "",
      "userDefined40": "",
      "userDefined41": "",
      "userDefined42": "",
      "pseudocode": "",
      "userDefined43": "",
      "userDefined44": "",
      "userDefined45": "",
      "targetTableAlias": "",
      "baseSourceSystemName": "",
      "sourceTableName": "",
      "mappingSequenceId": 0,
      "userDefined10": "",
      "userDefined11": "",
      "baseSourceSystemEnvironmentName": "",
      "userDefined12": "",
      "targetPrimaryKeyFlag": false,
      "lookupColumn": "",
      "sourceColumnLength": "",
      "sourceBusinessKeyFlag": false,
      "userDefined13": "",
      "sourceNaturalKeyFlag": false,
      "userDefined14": "",
      "userDefined15": "",
      "userDefined16": "",
      "userDefined17": "",
      "targetColumnNullableFlag": false,
      "userDefined18": "",
      "userDefined19": "",
      "lookupOn": "",
      "sourceColumnDBDefaultValue": "",
      "targetColumnLength": "",
      "userDefined20": "",
      "sourceColumnComments": "",
      "userDefined21": "",
      "userDefined22": "",
      "userDefined23": "",
      "sourceSystemName": "",
      "targetSystemId": -1,
      "targetSDIDescription": "",
      "targetTableClass": "",
      "mappingId": 1,
      "specificationArtifacts": "",
      "transformationLookupCondition": "",
      "sourceColumnNullableFlag": false,
      "targetColumnName": "",
      "sourceColumnClass": "",
      "targetColumnETLDefaultValue": "",
      "baseTargetSystemEnvironmentName": "",
      "baseTargetSystemName": "",
      "targetXPath": "",
      "sourceColumnName": "",
      "sourceXPath": "",
      "columnMappingCompleteFlag": false,
      "rdmReferenceTable": "",
      "targetColumnDatatype": "",
      "sourceTableType" : "",
      "targetTableType" : "",
      "sourceEntityUID" : "",
      "targetEntityUID" : "",
      "sourceEnvBusinessEntityType": "",
      "sourceTableBusinessEntityType": "",
      "targetEnvBusinessEntityType": "",
      "targetTableBusinessEntityType": ""
      }
      ],
      "userDefined14": "",
      "userDefined15": "",
      "userDefined16": "",
      "published": false,
      "userDefined17": "",
      "targetUpdateStrategy": "",
      "userDefined18": "",
      "actualETLEffort": 0,
      "userDefined19": "",
      "testDisposition": " ",
      "versionLabel": "",
      "plannedETLEffortUnits": "",
      "plannedETLEffort": 0,
      "userDefined8": "",
      "userDefined20": "",
      "userDefined9": "",
      "userDefined21": "",
      "userDefined6": "",
      "userDefined22": "",
      "userDefined7": "",
      "userDefined23": "",
      "userDefined4": "",
      "plannedMappingEffortUnits": "",
      "userDefined5": "",
      "userDefined2": "",
      "userDefined3": "",
      "nodeId": "",
      "userDefined1": "",
      "mappingSubStateId": 0,
      "mappingStateId": 0,
      "changedDescription": "",
      "actualETLEffortUnits": "",
      "userDefined24": "",
      "userDefined25": "",
      "plannedMappingEffort": 0,
      "userDefined26": "",
      "userDefined27": "",
      "userDefined28": "",
      "userDefined29": "",
      "actualDevelopLevelOfEffort": null,
      "actualNotes": "",
      "userDefined30": "",
      "userDefined31": "",
      "testingNotes": "",
      "actualMappingEffort": 0,
      "userDefined32": "",
      "userDefined33": "",
      "sourceExtractQuery": "",
      "userDefined34": "",
      "targetUpgateStrategyNotes": "",
      "plannedDevelopmentLevelOfEffort": null,
      "sourceExtractDescription": "",
      "userDefined35": "",
      "mappingDescription": "",
      "userDefined36": "",
      "userDefined37": "",
      "userDefined38": "",
      "userDefined39": "",
      "mappingStateName": null,
      "userDefined40": "",
      "userDefined41": "",
      "plannedNotes": "",
      "userDefined42": "",
      "userDefined43": "",
      "userDefined44": "",
      "userDefined45": "",
      "mappingDocuments": null,
      "mappingSpecVersion": 0,
      "effectiveDate": null
      }
      ]

    Since:
      13.0

  - ### getSubjectByProject

    public String getSubjectByProject(String userName, String password, String outputFormat, int projectId, String subjectHierarchy)
    Returns Subject object for the specified projectId and subjectHierarchy, in the specified outputFormat. OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Specifying the projectId and subjectHierarchy are mandatory Based on which it returns all the details of subject.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `projectId` - int
      `subjectHierarchy` - - String - Example for subjectHierarchy input parameter : s1/s2/s3
    Returns:
      String - RequestStatus object in the form of JSON or XML String.
    Since:
      12.1

  - ### getSubjectByHierarchy

    public String getSubjectByHierarchy(String userName, String password, String outputFormat, String projectName, String subjectHierarchy)
    Returns Subject object for the specified projectName and subjectHierarchy, in the specified outputFormat. OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Specifying the projectName and subjectHierarchy are mandatory Based on which it returns all the details of subject.
    Parameters:
      `userName` - - String
      `password` - - String
      `outputFormat` - String - Valid values: JSON or XML
      `projectName` - - String
      `subjectHierarchy` - - String - Example for subjectHierarchy input parameter : s1/s2/s3
    Returns:
      String - RequestStatus object in the form of JSON or XML String.
    Since:
      12.1

  - ### syncMetadata

    public String syncMetadata(String userName, String password, String outputFormat, String mapIdsJsonArray)
    This function is used to sync the source and target metadata information in mapping specifications for the specified map Ids. Specifying the mapIdsJsonArray is mandatory.
    Specification of the outputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `userName` - String
      `password` - String
      `outputFormat` - String - Valid values: JSON or XML
      `mapIdsJsonArray` - String
    Returns:
      String - RequestStatus object in the form of JSON or XML String.

      Sample 'mapIds' JSONArray :
      [1,2]

    Since:
      14.0